sap.ui.controller("sas.fscf.Application", {

    getView: function() {
        return this.oView;
    },

    onInit: function () {
		sas.fscf.getEmptyRuleExpressions = function() {
			return {type:"ExpressionList",expressions:[{type:"IF",condition:{"type": "AND","operator": "AND",expressions:[]},properties:{view:"grid"},thenActions:[]}]};
		};
    },

    onBeforeRendering: function () {
    },

    onAfterRendering: function () {
    	sas.fscf.sessionUserActivity = function () {
    		sas.eventBus.publish(sas.timeoutManager.events.USER_ACTIVE);
    	};
    	//sas.eventBus.subscribe(sas.timeoutManager.events.USER_ACTIVE,function(){
    	//	console.log("USER ACTIVITY " + new Date().getTime());
    	//});
    	sas.fscf.banner = sap.ui.getCore().byId("sas_fscf_appContainer_banner");
    	sas.fscf.banner.setShowNotifications(false);
//    	sas.fscf.banner.setHelpUrl("http://fmlaxdev07.unx.sas.com:8080/SASWebDoc/?show=topicContainer&productId=FRAUDAPPMID%3A4.2&topicUrl=frm.hlp%2F" + sas.fscf.helpUrlLookup['ITab' + sas.config.get('fscf').tabs[0].name] + "&query=&_locale=" + window['sap-ui-config'].language);
    	sas.fscf.banner.setHelpUrl('common/help.jsp');
    	sas.fscf.banner.setUserName(sas.config.get('fscf').userId);
    	sas.fscf.banner.setUserLastLoginMsg = function (lastLoginMsg) {
    		$('#banner-userLastLoginMsg').remove();
    		$('#sas_fscf_appContainer_banner-bannerRight').prepend('<span id="banner-userLastLoginMsg" style="font-size:0.7rem">' + lastLoginMsg + '</span>');
    	};
    	sas.fscf.banner.onAfterRendering = function () {
        	this.setUserLastLoginMsg(sas.config.get('fscf').userLastLoginMsg);
    	};
    	sas.fscf.banner.addExtraButton = function (title, idFragment, onclick, icon, fontSize) {
    		var extraBB = [];
    		extraBB[extraBB.length] = '<button title="' + title + '" class="bannerExtraButton sapMBtn sapMBtnBase sasBannerHelp sasIconBtn" id="banner-' + idFragment + '" aria-label="' + title + '" type="button" data-sap-ui="banner-' + idFragment + '" onclick="' + onclick + '">';
    		extraBB[extraBB.length] = '<div class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMFocusable" id="banner-' + idFragment + '-inner">';
    		extraBB[extraBB.length] = '<span class="sapMBtnCustomIcon sapMBtnIcon sapUiIcon" id="banner-' + idFragment + '-img" role="img" style=\'font-family: "sas-icons"; font-size: ' + (fontSize ? fontSize : '1rem') + '; line-height: 1.4rem; width: 1.25rem \' data-sap-ui="banner-' + idFragment + '-img" data-sap-ui-icon-content="' + icon + '"></span>';
    		extraBB[extraBB.length] = '</div>';
    		extraBB[extraBB.length] = '</button>';
    		if ($('#banner-userLastLoginMsg').length) {
    			$('#banner-userLastLoginMsg').after(extraBB.join(''));
    		} else {
        		$('#sas_fscf_appContainer_banner-bannerRight').prepend(extraBB.join(''));
    		}
    	};
    	sas.fscf.banner.removeAllExtraButtons = function () {
    		$('.bannerExtraButton').remove();
    	};
    	sas.fscf.banner.handleTabChange = function (tabKey) {
    		sas.fscf.setCookie("cf_lastTab", tabKey);
    		this.removeAllExtraButtons();
//    		this.setHelpUrl("http://fmlaxdev07.unx.sas.com:8080/SASWebDoc/?show=topicContainer&productId=FRAUDAPPMID%3A4.2&topicUrl=frm.hlp%2F" + sas.fscf.helpUrlLookup[tabKey] + "&query=&_locale=" + window['sap-ui-config'].language);
    		sas.fscf.banner.setHelpUrl('common/help.jsp');
    	};
    	if (sas.fscf.tabBar) {
        	sas.fscf.tabBar.attachSelect(function(e){this.handleTabChange(e.mParameters.key)}, sas.fscf.banner);
    	}
    	sas.fscf.getCurrentOverviewToolbar = function(){
        	if (sas.fscf.tabBar) {
        		return sap.ui.getCore().byId(sap.ui.getCore().byId(sas.fscf.tabBar.getSelectedKey()).getContent()[0].sId + "OverviewViewToolbar");
        	} else {
        		return sap.ui.getCore().byId(sas.fscf.singleView.sId + "OverviewViewToolbar");
        	}
    	};
    	sas.fscf.getCurrentDetailToolbar = function(){
        	if (sas.fscf.tabBar) {
        		return sap.ui.getCore().byId(sap.ui.getCore().byId(sas.fscf.tabBar.getSelectedKey()).getContent()[0].sId + "DetailsViewToolbar");
        	} else {
        		return sap.ui.getCore().byId(sas.fscf.singleView.sId + "DetailsViewToolbar");
        	}
    	};
    	sas.fscf.getCurrentDetailView = function(){
        	if (sas.fscf.tabBar) {
        		return sap.ui.getCore().byId(sap.ui.getCore().byId(sas.fscf.tabBar.getSelectedKey()).getContent()[0].sId + "DetailsView");
        	} else {
        		return sap.ui.getCore().byId(sas.fscf.singleView.sId + "DetailsView");
        	}
    	};
    	sas.fscf.getCurrentPageView = function(){
        	if (sas.fscf.tabBar) {
        		return sap.ui.getCore().byId(sas.fscf.tabBar.getSelectedKey()).getContent()[0];
        	} else {
        		return sas.fscf.singleView;
        	}
    	};
    	sas.fscf.openPopout = function(tabName){
    		return window.open("fcmAppMain.sj?method=popoutTab&tabName="+tabName, "FCMPopoutWin",
    				"toolbar=no,location=no,menubar=no,scrollbars=yes,status=yes,"+
    				"resizable=yes,copyhistory=no,left=" + (screen.width - (screen.width * 0.6) - 20) + 
    				",top=" + (screen.height - (screen.height * 0.6) - 65) +
    				",width=" + (screen.width * 0.6) + 
    				",height=" + (screen.height * 0.6));
    	};
    	sas.fscf.explore = function(multiOrgId, field, value){
    		var win = sas.fscf.openPopout("explore");
    		$(win.document).ready(function() {
    			var count = 0;
    			var timer = setInterval(function () {
    				if ((win.sas && win.sap && win.sap.ui.getCore().byId("ExplorePageGuidedView")) || (count > 15)) {
    	    			clearInterval(timer);
    	    			win.sas.ajax({url:"rest/multiorgs/" + multiOrgId, type: "GET", dataType:"json"})
    	    		  	  .done(function(oData){
    	    		  		  if (oData.items) {
    	    		  			  var multiOrgKey = oData.items[0].key; 
    	    			  		  
    	      					  var exps = win.sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition.expressions;
	    	    				  exps[exps.length] = {
	    	   						"id": "F-1",
	    	   	                        "type": "COMPARE",
	    	   	                        "operator": "EQUAL",
	    	   	                        "fieldId": 24,
	    	   	                        "fieldName": "SMH_MULTI_ORG_NODE_KEY",
	    	   	                        "fieldType": "Character",
	    	   	                        "value": multiOrgKey
    	    	                  };
	    	    				  exps[exps.length] = {
	    	   							"id": "F-2",
	    	   	                        "type": "COMPARE",
	    	   	                        "operator": "EQUAL",
	    	   	                        "fieldId": 24,
	    	   	                        "fieldName": field,
	    	   	                        "fieldType": "Character",
	    	   	                        "value": value
	    	       	              };
	    	    				  win.sas.fscf.loadRule(win.sap.ui.getCore().byId("ExplorePageGuidedView"));
    	    		  		  }
    	    			  }).fail(function(oObj,textStatus){
	      					  var exps = win.sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition.expressions;
    	    				  exps[exps.length] = {
    	   						"id": "F-1",
    	   	                        "type": "COMPARE",
    	   	                        "operator": "IN",
    	   	                        "fieldId": 24,
    	   	                        "fieldName": "SMH_MULTI_ORG_NODE_KEY",
    	   	                        "fieldType": "Character",
    	   	                        "values": []
	    	                  };
    	    				  exps[exps.length] = {
    	   							"id": "F-2",
    	   	                        "type": "COMPARE",
    	   	                        "operator": "EQUAL",
    	   	                        "fieldId": 24,
    	   	                        "fieldName": field,
    	   	                        "fieldType": "Character",
    	   	                        "value": value
    	       	              };
    	    				  win.sas.fscf.loadRule(win.sap.ui.getCore().byId("ExplorePageGuidedView"));
    	    			});		    	    			
    				} else {
    					count++;
    				}
    			}, 500);
    		});
    	};
    	if (sas.fscf.tabBar) {
        	this.oView.handleTabChange(sas.fscf.tabBar.getSelectedKey());
    	} else {
            var tabs = sas.config.get('fscf').tabs;
        	this.oView.handleTabChange("ITab" + tabs[0].name);
    	}
    },

    onExit: function () {
    }
});
