sap.ui.jsview("sas.fscf.views.RulesPageDetails", {
    getControllerName: function () {
        return "sas.fscf.views.RulesPageDetails";
    },

    createContent: function(oController) {
        jQuery.sap.require("sap.m.Toolbar");
        jQuery.sap.require("sas.hc.m.Button");

        var oToolbar = new sap.m.Toolbar({
    	    id: this.sId + 'Toolbar'
    	});
        oToolbar.setContentFor = function(type, id, mustRequestApprovalToPromote, mustRequestApprovalToDeactivate, id2,canModify) {
        	oToolbar.destroyContent();
        	//console.log("type = " + type);
    		var _this = this;
        	if (type == 'Coding') {
       			jQuery.sap.require("sas.hc.m.ActionSheet");

       			if (!this._newActionSheet) {
       		      this._newActionSheet = new sas.hc.m.ActionSheet({
       		         title: sas.fscf.rb.getText('rules.rulesListDetailMenu.chooseYourAction.txt'),
       		         showCancelButton: true,
       		         placement: sap.m.PlacementType.Bottom,
       		         buttons: [
       		             new sas.hc.m.Button({
                     	     id: this.sId + 'GuidedApproachButton',
       		                 text: sas.fscf.rb.getText('rules.rulesListDetailMenu.guidedApproach.txt'),
       		                 icon: "sap-icon://hc/form",
       	    				 press: function() {
       	    					 sas.fscf.ruleApproach = sas.fscf.RULE_APPROACH_GUIDED;
       	    					 sas.fscf.getCurrentPageView().jsonRule = null;
       	    					 sas.fscf.getCurrentPageView().getNewRuleDialog().open();
      	    				 }
       		             }),
/*     		             new sas.hc.m.Button({
                     	     id: this.sId + 'CodingApproachButton',
       		                 text: sas.fscf.rb.getText('rules.rulesListDetailMenu.codingApproach.txt'),
       		                 icon: "sap-icon://hc/code",
       	    				 press: function() {
       	    					 sas.fscf.ruleApproach = sas.fscf.RULE_APPROACH_CODING;
       	    					 sas.fscf.getCurrentPageView().jsonRule = null;
       	    					 sas.fscf.getCurrentPageView().getNewRuleDialog().open();
      	    				 }
       		             }),*/
       		             new sas.hc.m.Button({
                     	     id: this.sId + 'ClassicCodeEditorButton',
       		                 text: sas.fscf.rb.getText('rules.rulesListDetailMenu.codeEditor.txt'),
       		                 icon: "sap-icon://hc/code",
       	    				 press: function() {
       	    					 frames['detail'].newRule(true);
      	    				 }
       		             })
       		         ]
       		      });
       			}

        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewRuleButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.newRule.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        enabled: canModify,
   				        press: function(e) {
       				    	_this._newActionSheet.openBy(e.getSource());
   				        }
         		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'EditRuleButton',
    				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.editRule.txt"),
    				    icon : "sap-icon://hc/edit",
    				    enabled: canModify,
    				    press: function() {
       				    	frames['detail'].processRequest('modifyRule','',true);
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'PromoteToTestingButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.promoteToTesting.txt"),
   				        icon : "sap-icon://hc/performanceMonitor",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].processMultiSelectRequest('processStateTransition', 'Testing');
   				        }
         		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
            			id: this.sId + 'DeleteRuleButton',
    				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.deleteRule.txt"),
    				    icon : "sap-icon://hc/delete",
    				    enabled: canModify,
    				    press: function() {
   				        	frames['detail'].processMultiSelectRequest('processStateTransition', 'Trash');
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHistoryButton',
    				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.showHistory.txt"),
    				    icon : "sap-icon://hc/history",
    				    press: function() {
   				        	frames['detail'].processRequest('getRuleVersions', '');
    				    }
        		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ExportButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.export.txt"),
       				    icon : "sap-icon://hc/export",
       				    enabled: canModify,
       				    press: function() {
   				        	frames['detail'].processMultiSelectRequest('exportRules', '', false, type, true);
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
   				        	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrioritizeButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.prioritize.txt"),
       				    icon : "sap-icon://hc/ranking",
       				    enabled: canModify,
       				    press: function() {
   				        	frames['detail'].prioritizeRules();
       				    }
           		    })
           		);
        	}
        	else if (type == 'Testing') {
        		if (mustRequestApprovalToPromote) {
            		oToolbar.addContent(
               		    new sas.hc.m.Button({
                    	    id: this.sId + 'RequestApprovalButton',
       				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.requestApproval.txt"),
       				        icon : "sap-icon://hr-approval",
       				        enabled: canModify,
       				        press: function() {
       				        	frames['detail'].showRequestApprovalPopup(type, 'rules.ruleAction.js.toProductionApproval.alert.fmt.txt', id);
       				        }
              		    })
            		);
        		}
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'PromoteToProductionButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.promoteToProduction.txt"),
   				        icon : "sap-icon://hc/deployedJob",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].processMultiSelectRequest('processStateTransition', 'Production');
   				        }
         		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'MoveToCodingButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.moveToCoding.txt"),
   				        icon : "sap-icon://hc/code",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].processMultiSelectRequest('processStateTransition', 'Coding');
   				        }
          		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHistoryButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.showHistory.txt"),
       				    icon : "sap-icon://hc/history",
       				    press: function() {
       				    	frames['detail'].processRequest('getRuleVersions', '');
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ExportButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.export.txt"),
       				    icon : "sap-icon://hc/export",
       				    enabled: canModify,
       				    press: function() {
   				        	frames['detail'].processMultiSelectRequest('exportRules', '', false, type, true);
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
       				    	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        	}
        	else if (type == 'Production') {
        		if (mustRequestApprovalToDeactivate) {
            		oToolbar.addContent(
               		    new sas.hc.m.Button({
                    	    id: this.sId + 'RequestApprovalButton',
       				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.requestApproval.txt"),
       				        icon : "sap-icon://hr-approval",
       				        enabled: canModify,
       				        press: function() {
       				        	frames['detail'].showRequestApprovalPopup(type, 'rules.ruleAction.js.toDeactivatedApproval.alert.fmt.txt', id);
       				        }
              		    })
            		);
        		}
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'DeactivateButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.deactivate.txt"),
   				        icon : "sap-icon://hc/uncheckAll",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].processMultiSelectRequest('processStateTransition', 'Deactivated');
   				        }
         		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'CreateNewVersionButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.createNewVersion.txt"),
   				        icon : "sap-icon://hc/code",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].processRequest('createVersion', 'Coding');
   				        }
          		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHistoryButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.showHistory.txt"),
       				    icon : "sap-icon://hc/history",
       				    press: function() {
       				    	frames['detail'].processRequest('getRuleVersions', '');
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ExportButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.export.txt"),
       				    icon : "sap-icon://hc/export",
       				    enabled: canModify,
       				    press: function() {
   				        	frames['detail'].processMultiSelectRequest('exportRules', '', false, type, true);
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
       				    	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        	}
        	else if (type == 'Deactivated') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'CreateNewVersionButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.createNewVersion.txt"),
   				        icon : "sap-icon://hc/code",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].processRequest('createVersion', 'Coding');
   				        }
          		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'DeleteRuleButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.deleteRule.txt"),
   				        icon : "sap-icon://hc/delete",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].processMultiSelectRequest('processStateTransition', 'Trash');
   				        }
          		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHistoryButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.showHistory.txt"),
       				    icon : "sap-icon://hc/history",
       				    press: function() {
       				    	frames['detail'].processRequest('getRuleVersions', '');
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
       				    	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        	}
        	else if (type == 'Trash') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'DeleteRuleButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.deleteRule.txt"),
   				        icon : "sap-icon://hc/delete",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].processMultiSelectRequest('deleteRules', '');
   				        }
          		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'EmptyTrashButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.emptyTrash.txt"),
   				        icon : "sap-icon://hc/delete",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].emptyTrash()
   				        }
          		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'CreateNewVersionButton',
   				        text: sas.fscf.rb.getText("rules.rulesListDetailMenu.createNewVersion.txt"),
   				        icon : "sap-icon://hc/code",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].processRequest('createVersion', 'Coding');
   				        }
          		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHistoryButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.showHistory.txt"),
       				    icon : "sap-icon://hc/history",
       				    press: function() {
       				    	frames['detail'].processRequest('getRuleVersions', '');
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
       				    	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        	}
        	else if (type == 'searchResults') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'ShowHistoryButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.showHistory.txt"),
       				    icon : "sap-icon://hc/history",
       				    press: function() {
       				    	frames['detail'].processRequest('getRuleVersions', '');
       				    }
          		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
       				    	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        	}
        	else if (type == 'getRuleVersions') {
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
       				    	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        	}
        	else if (type == 'estimates') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'NewEstimationButton',
    				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.newEstimation.txt"),
    				    icon : "sap-icon://hc/newStarburst",
    				    press: function() {
    				    	frames['detail'].newEstimation();
    				    }
        		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ViewResultsButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.viewResults.txt"),
       				    icon : "sap-icon://hc/file",
       				    press: function() {
       				    	frames['detail'].showEstimateReport();
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ViewCodeButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.viewCode.txt"),
       				    icon : "sap-icon://hc/code",
       				    press: function() {
       				    	frames['detail'].showSASCode();
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ViewLogButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.viewLog.txt"),
       				    icon : "sap-icon://hc/log",
       				    press: function() {
       				    	frames['detail'].showSASLog();
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'CancelButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.cancel.txt"),
       				    icon : "sap-icon://hc/cancel",
       				    press: function() {
       				    	frames['detail'].cancelEstimates();
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.delete.txt"),
       				    icon : "sap-icon://hc/delete",
       				    press: function() {
       				    	frames['detail'].deleteEstimates();
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
       				    	frames['detail'].printEstimations();
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'RefreshButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.refresh.txt"),
       				    icon : "sap-icon://hc/refresh",
       				    press: function() {
       				    	frames['detail'].document.location.href = frames['detail'].document.location.href;
       				    }
           		    })
           		);
        	}
        	else if (type == 'estimation') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'RunEstimationButton',
    				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.runEstimation.txt"),
    				    icon : "sap-icon://hc/play",
    				    press: function() {
    				    	frames['detail'].runEstimation(false);
    				    }
        		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'DebugEstimationButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.debugEstimation.txt"),
       				    icon : "sap-icon://hc/optimizationOverrideScenario",
       				    press: function() {
    				    	frames['detail'].runEstimation(true);
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHistoryButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.showHistory.txt"),
       				    icon : "sap-icon://hc/history",
       				    press: function() {
       				    	frames['detail'].processRequest('getRuleVersions', '');
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
       				    	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ListEstimationsButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.listEstimations.txt"),
       				    icon : "sap-icon://hc/file",
       				    press: function() {
       				    	frames['detail'].listEstimations();
       				    }
           		    })
           		);
        	}
        	else if (type == 'estimatesReport') {
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'NewEstimationButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.newEstimation.txt"),
       				    icon : "sap-icon://hc/newStarburst",
       				    press: function() {
       				    	frames['detail'].newEstimation();
       				    }
           		    })
           		);
           		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ViewResultsButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.viewResults.txt"),
       				    icon : "sap-icon://hc/file",
       				    press: function() {
       				    	frames['detail']._showEstimateReport(id);
       				    }
           		    })
           		);
          		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ViewCodeButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.viewCode.txt"),
       				    icon : "sap-icon://hc/code",
       				    press: function() {
       				    	frames['detail']._showSASCode(id);
       				    }
           		    })
           		);
          		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ViewLogButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.viewLog.txt"),
       				    icon : "sap-icon://hc/log",
       				    press: function() {
       				    	frames['detail']._showSASLog(id);
       				    }
           		    })
           		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'ListEstimationsButton',
       				    text: sas.fscf.rb.getText("rules.ruleEstimatesDetailMenu.listEstimations.txt"),
       				    icon : "sap-icon://hc/file",
       				    press: function() {
       				    	frames['detail'].listEstimations();
       				    }
           		    })
           		);
        	}
        	else if (type == 'Current') {
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
   				        	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        	}
        	else if(type=='Active'){
        		oToolbar.addContent(new sas.hc.m.Button({
	                id: this.sId + 'DisableButton',
	                icon: sas.icons.HC.DEACTIVATE,
	                tooltip: sas.fscf.rb.getText("rules.rulesPage.rules.production.actions.disable.txt"),
                    showDownArrowIconOnly: true,
	                enabled: canModify,
	                //menu:  oDisableMenu,
                    press: function(){
    	                frames['detail'].changeRuleEnableState(false, sas.fscf.rb.getText("rules.rulesPage.ruleAction.disable.txt"))
                    }
	            }));
	            oToolbar.addContent(new sas.hc.m.Button({
	                id: this.sId + 'EnableButton',
	                icon: sas.icons.HC.ACTIVATE,
	                tooltip: sas.fscf.rb.getText("rules.rulesPage.rules.production.actions.enable.txt"),
	                enabled: canModify,
	                press: function(){
	                	frames['detail'].changeRuleEnableState(true, sas.fscf.rb.getText("rules.rulesPage.ruleAction.enable.txt"))
	                }
	               
	            }));
           		/**menu option**/
//           		var enableButton = new sas.hc.m.MenuButton({
//    	        id: this.sId + 'EnableMenuButton',
//        	    text: "Enable",
//        	    icon : "sap-icon://hc/activate"
//           		});
//           		//Create the menu
//                var oMenu1 = new sas.hc.m.Menu("enableMenu1", {
//                });
//                var oMenuItem1 = new sas.hc.m.MenuItem("business", {
//                	text: "Business",
//                	press: function() {
//                   		//frames['overview'].showTaskView("listRules");
//                	}
//                });
//                oMenu1.addItem(oMenuItem1);
//                var oMenuItem2 = new sas.hc.m.MenuItem("execution", {
//                	text: "Execution",
//                	press: function() {
//                   		//frames['overview'].showTaskView("listRules");
//                	}
//                });
//                oMenu1.addItem(oMenuItem2);
//                //Add the Menus to the MenuButtons
//                enableButton.setMenu(oMenu1);
//                oToolbar.addContent(enableButton);
//                
//                /**menu option**/
//           		var disableButton = new sas.hc.m.MenuButton({
//    	        id: this.sId + 'DisableMenuButton',
//        	    text: "Disable",
//        	    icon : "sap-icon://hc/deactivate"
//           		});
//           		//Create the menu
//                var oMenu2 = new sas.hc.m.Menu("disableMenu1", {
//                });
//                var oMenuItem3 = new sas.hc.m.MenuItem("disableBusiness", {
//                	text: "Business",
//                	press: function() {
//                   		//frames['overview'].showTaskView("listRules");
//                	}
//                });
//                oMenu2.addItem(oMenuItem3);
//                var oMenuItem4 = new sas.hc.m.MenuItem("disableExecution", {
//                	text: "Execution",
//                	press: function() {
//                   		//frames['overview'].showTaskView("listRules");
//                	}
//                });
//                oMenu2.addItem(oMenuItem4);
//                //Add the Menus to the MenuButtons
//                disableButton.setMenu(oMenu2);
//                oToolbar.addContent(disableButton);
        	}
        	else if (type == 'build') {
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
       				    text: sas.fscf.rb.getText("rules.rulesListDetailMenu.print.txt"),
       				    icon : "sap-icon://hc/print",
       				    press: function() {
   				        	frames['detail'].processMultiSelectRequest('printRules', '', false);
       				    }
           		    })
           		);
        	}
        	else if (type == 'lookupLists') {


		        if (sas.fscf.enableDynamicLookupLists) {
	        		jQuery.sap.require("sas.hc.m.ActionSheet");

		        	if (this._newLookupListActionSheet == undefined) {

		        		this._newLookupListActionSheet= new sas.hc.m.ActionSheet ({
		        			title:sas.fscf.rb.getText('rules.rulesLookupListDetailMenu.chooseYourLookupListType.txt'),
                            	showCancelButton:true,
                                placement:sap.m.PlacementType.Bottom,
                                buttons: [
                                       new sas.hc.m.Button({
                                       id: this.sId + 'LookupList',
                                           text: sas.fscf.rb.getText('rules.rulesLookupListDetailMenu.lookupList.txt'),
                                           icon: "sap-icon://hc/code",
                                           press: function () {
                                        	    frames['detail'].newLookupList();
                                           }
                                       }),
                                       new sas.hc.m.Button({
                                       id: this.sId + 'AnalystList',
                                           text: sas.fscf.rb.getText('rules.rulesLookupListDetailMenu.analystList.txt'),
                                           icon: "sap-icon://hc/code",
                                           press: function() {
                                       	   		frames['detail'].newAnalystLookupList();
                                           }
                                       })
                                ]
                        });
		        	}
		        }

        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewButton',
   				        text: sas.fscf.rb.getText("fcm.overview.new.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function(e) {
                            if (sas.fscf.enableDynamicLookupLists)
                            {
   					           if (_this._newLookupListActionSheet) {
   					        	   _this._newLookupListActionSheet.openBy(e.getSource());
   					           }
   					           else {
   					        	   frames['detail'].newLookupList();
   					           }
                            }
                            else  {
                            	frames['detail'].newLookupList();
                            }
   				        }
         		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'EditButton',
    				    text: sas.fscf.rb.getText("fcm.application.edit.txt"),
    				    icon : "sap-icon://hc/edit",
    				    press: function() {
    				    	frames['detail'].editLookupList();
    				    }
        		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteButton',
       				    text: sas.fscf.rb.getText("fcm.overview.delete.txt"),
       				    icon : "sap-icon://hc/delete",
       				    press: function() {
   				        	frames['detail'].deleteLookupLists();
       				    }
           		    })
           		);
        	}
        	else if (type == 'predefinedTransactionList') {
        	     oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'SaveButton',
   				        text: sas.fscf.rb.getText("fcm.application.save.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        enabled: canModify,
   				        press: function() {
   				        	frames['detail'].saveTransactionList();//saves the tran type business unit association
   				        }
         		    })
        		);
        	}
        	else if (type == 'customTransactionsFolder') {
        		oToolbar.addContent(
               		    new sas.hc.m.Button({
                    	    id: this.sId + 'NewButton',
       				        text: sas.fscf.rb.getText("transaction.newCustomTransaction.txt"),
       				        icon : "sap-icon://hc/newStarburst",
       				        enabled: canModify,
       				        press: function() {
       				        	frames['detail'].doNewTransactionAction();//creates new custom transaction type without component associations
       				        }
             		    })
            	);
        	}
        	else if (type == 'transactionActionsFolder') {
//        		oToolbar.addContent(
//               		    new sas.hc.m.Button({
//                    	    id: this.sId + 'NewButton',
//       				        text: sas.fscf.rb.getText("transaction.newCustomTransaction.txt"),
//       				        icon : "sap-icon://hc/newStarburst",
//       				        enabled: canModify,
//       				        press: function() {
//       				        	frames['detail'].doNewTransactionAction();//creates new custom transaction type without component associations
//       				        }
//             		    })
//            	);
        	}
        	else if (type == 'predefinedTransaction') {
        		oToolbar.addContent(
               		    new sas.hc.m.Button({
                    	    id: this.sId + 'NewButton',
       				        text: sas.fscf.rb.getText("transaction.returnToList.txt"),
       				        icon : "sap-icon://hc/reset",
       				        enabled: canModify,
       				        press: function() {
       				        	frames['detail'].returnToList();//returns to list of predefined transactions
       				        }
             		    })
            	);
        	}
        	else if (type == 'customTransaction') {
        		oToolbar.addContent(
               		    new sas.hc.m.Button({
                    	    id: this.sId + 'NewButton',
       				        text: sas.fscf.rb.getText("transaction.newCustomTransaction.txt"),
       				        icon : "sap-icon://hc/newStarburst",
       				        enabled: canModify,
       				        press: function() {
       				        	frames['detail'].doNewTransactionAction();//creates new custom transaction type without component associations
       				        }
             		    })
            	);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'SaveButton',
    				    text: sas.fscf.rb.getText("fcm.application.save.txt"),
    				    icon : "sap-icon://hc/edit",
    				    enabled: canModify,
    				    press: function() {
    				    	frames['detail'].doSaveAction();//saves new custom transaction type with component associations
    				    }
        		    })
        		);
        		oToolbar.addContent(
                   		new sas.hc.m.Button({
                    	    id: this.sId + 'DeleteButton',
           				    text: sas.fscf.rb.getText("fcm.overview.delete.txt"),
           				    icon : "sap-icon://hc/delete",
           				    enabled: id2,
           				    press: function() {
       				        	frames['detail'].doDeleteAction();//deletes custom transaction type
           				    }
               		    })
               		);
        	}
        	else if (type == 'transactionActionsList') {
       	     oToolbar.addContent(
          		    new sas.hc.m.Button({
               	    id: this.sId + 'SaveButton',
  				        text: sas.fscf.rb.getText("fcm.application.save.txt"),
  				        icon : "sap-icon://hc/newStarburst",
  				        enabled: canModify,
  				        press: function() {
  				        	frames['detail'].saveTransactionActionsList();//saves the actions for a transaction type
  				        }
        		    })
       		);
       	    }
        	else if (type == 'contentFiles') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'ActivateButton',
   				        text: sas.fscf.rb.getText("fcm.application.register.txt"),
   				        icon : "sap-icon://hc/edit",
   				        press: function() {
   				        	frames['detail'].activateLookupLists();
   				        }
         		    })
        		);
            oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteButton',
       				    text: sas.fscf.rb.getText("fcm.overview.delete.txt"),
       				    icon : "sap-icon://hc/delete",
       				    press: function() {
   				        	frames['detail'].deleteLookupLists();
       				    }
           		    })
           		);
        	}
        	else if (type == 'viewLookupList') {
        	   var lookupListFileName = frames['detail'].selectedLookupListFile;
            if (lookupListFileName != null && lookupListFileName.indexOf(".sor") == -1) {
               oToolbar.addContent(
                     new sas.hc.m.Button({
                        id: this.sId + 'ReloadButton',
                        text: sas.fscf.rb.getText("fcm.application.reload.txt"),
                        icon : "sap-icon://hc/refresh",
                        press: function() {
                           frames['detail'].reloadLookupList();
                        }
                     })
               );
            }
            oToolbar.addContent(
                  new sas.hc.m.Button({
                      id: this.sId + 'UploadButton',
                   text: sas.fscf.rb.getText("fcm.application.upload.txt"),
                   icon : "sap-icon://hc/upload",
                   press: function() {
                     frames['detail'].uploadContentFile();
                   }
                })
            );
            oToolbar.addContent(
                     new sas.hc.m.Button({
                      id: this.sId + 'DownloadButton',
                      text: sas.fscf.rb.getText("fcm.application.download.txt"),
                      icon : "sap-icon://hc/download",
                      press: function() {
                        frames['detail'].downloadContentFile();
                      }
                   })
               );
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'CancelButton',
       				    text: sas.fscf.rb.getText("fcm.application.cancel.txt"),
       				    icon : "sap-icon://hc/cancel",
       				    press: function() {
   				        	frames['detail'].reshowLookupLists('list');
       				    }
           		    })
           		);
        	}
        	else if (type == 'newLookupList') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'SaveButton',
   				        text: sas.fscf.rb.getText("fcm.application.save.txt"),
   				        icon : "sap-icon://hc/save",
   				        press: function() {
   				        	frames['detail'].saveLookupListDefinition('list', 'RULEONLY');
   				        }
         		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'CancelButton',
       				    text: sas.fscf.rb.getText("fcm.application.cancel.txt"),
       				    icon : "sap-icon://hc/cancel",
       				    press: function() {
   				        	frames['detail'].reshowLookupLists('list');
       				    }
           		    })
           		);
        	}
           	else if (type == 'newAnalystList') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'SaveButton',
   				        text: sas.fscf.rb.getText("fcm.application.save.txt"),
   				        icon : "sap-icon://hc/save",
   				        press: function() {
   				        	frames['detail'].saveLookupListDefinition('list', 'ANALYST');
   				        }
         		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'CancelButton',
       				    text: sas.fscf.rb.getText("fcm.application.cancel.txt"),
       				    icon : "sap-icon://hc/cancel",
       				    press: function() {
   				        	frames['detail'].reshowLookupLists('list');
       				    }
           		    })
           		);
        	}
        	else if (type == 'editLookupList') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'SaveButton',
   				        text: sas.fscf.rb.getText("fcm.application.save.txt"),
   				        icon : "sap-icon://hc/save",
   				        press: function() {
   				        	frames['detail'].updateLookupListDefinition();
   				        }
         		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'CancelButton',
       				    text: sas.fscf.rb.getText("fcm.application.cancel.txt"),
       				    icon : "sap-icon://hc/cancel",
       				    press: function() {
   				        	frames['detail'].reshowLookupLists('list');
       				    }
           		    })
           		);
        	}
        	else if (type == 'newLookupListFromContent') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'SaveButton',
   				        text: sas.fscf.rb.getText("fcm.application.save.txt"),
   				        icon : "sap-icon://hc/save",
   				        press: function() {
   				        	frames['detail'].saveLookupListDefinition('content');
   				        }
         		    })
        		);
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'CancelButton',
       				    text: sas.fscf.rb.getText("fcm.application.cancel.txt"),
       				    icon : "sap-icon://hc/cancel",
       				    press: function() {
   				        	frames['detail'].reshowLookupLists('content');
       				    }
           		    })
           		);
        	}
        	else if (type == 'viewContentFile') {
            oToolbar.addContent(
                     new sas.hc.m.Button({
                      id: this.sId + 'DownloadButton',
                      text: sas.fscf.rb.getText("fcm.application.download.txt"),
                      icon : "sap-icon://hc/download",
                      press: function() {
                        frames['detail'].downloadContentFile();
                      }
                   })
               );
        		oToolbar.addContent(
               		new sas.hc.m.Button({
                	    id: this.sId + 'CancelButton',
       				    text: sas.fscf.rb.getText("fcm.application.cancel.txt"),
       				    icon : "sap-icon://hc/cancel",
       				    press: function() {
   				        	frames['detail'].reshowLookupLists('content');
       				    }
           		    })
           		);
        	}
        	else if (type == 'userVariables') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewVariableButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.newVariable.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function() {
   				        	frames['detail'].createVariable();
   				        }
         		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'EditVariableButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.editVariable.txt"),
    				    icon : "sap-icon://hc/edit",
    				    press: function() {
    				    	frames['detail'].editVariable();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteVariablesButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.deleteVariables.txt"),
    				    icon : "sap-icon://hc/delete",
    				    press: function() {
    				    	frames['detail'].deleteVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewSegmentButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.newSegment.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        enabled: false,
   				        press: function() {
   				        	frames['detail'].newSegment('','','V##',id2);
   				        }
          		    })
        		);
        		var viewButton = new sas.hc.m.Button({
            	    id: this.sId + 'ViewEditSegmentButton',
				    text: sas.fscf.rb.getText("variable.variableDetailMenu.viewSegment.txt"),
				    icon : "sap-icon://hc/file"
    		    });
        		viewButton._viewPress = function() {
			    	frames['detail']._viewSegment('','',id,id2);
			    };
    			viewButton._editPress = function() {
			    	frames['detail']._editSegment('','',id,id2);
    			};
    			viewButton.attachPress(viewButton._viewPress);
        		oToolbar.addContent(
        			viewButton
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'ExportVariablesButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.exportVariables.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function() {
   				        	frames['detail'].exportVariables();
   				        }
          		    })
        		);
        		oToolbar.addContent(
             		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.print.txt"),
    				    icon : "sap-icon://hc/print",
    				    press: function() {
    				    	frames['detail'].printVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHideUnusedButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt"),
    				    press: function() {
    				    	frames['detail'].showHideUnused();
    				    }
        		    })
        		);
        	}
        	else if (type == 'allUserVariables') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'EditVariableButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.editVariable.txt"),
    				    icon : "sap-icon://hc/edit",
    				    press: function() {
    				    	frames['detail'].editVariable();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteVariablesButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.deleteVariables.txt"),
    				    icon : "sap-icon://hc/delete",
    				    press: function() {
    				    	frames['detail'].deleteVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewSegmentButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.newSegment.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        enabled: false,
   				        press: function() {
   				        	frames['detail'].newSegment('','','V##',id2);
   				        }
          		    })
        		);
        		oToolbar.addContent(
             		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.print.txt"),
    				    icon : "sap-icon://hc/print",
    				    press: function() {
    				    	frames['detail'].printVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'ExportVariablesButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.exportVariables.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function() {
   				        	frames['detail'].exportVariables();
   				        }
          		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHideUnusedButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt"),
    				    press: function() {
    				    	frames['detail'].showHideUnused();
    				    }
        		    })
        		);
        	}
        	else if (type == 'inputClientVariables') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewVariableButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.newVariable.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function() {
   				        	frames['detail'].createVariable();
   				        }
         		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'EditVariableButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.editVariable.txt"),
    				    icon : "sap-icon://hc/edit",
    				    press: function() {
    				    	frames['detail'].editVariable();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteVariablesButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.deleteVariables.txt"),
    				    icon : "sap-icon://hc/delete",
    				    press: function() {
    				    	frames['detail'].deleteVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewSegmentButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.newSegment.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        enabled: false,
   				        press: function() {
   				        	frames['detail'].newSegment('','','I##',id2);
   				        }
          		    })
          		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'ExportVariablesButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.exportVariables.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function() {
   				        	frames['detail'].exportVariables();
   				        }
          		    })
        		);
        		var viewButton = new sas.hc.m.Button({
            	    id: this.sId + 'ViewEditSegmentButton',
				    text: sas.fscf.rb.getText("variable.variableDetailMenu.viewSegment.txt"),
				    icon : "sap-icon://hc/file"
    		    });
        		viewButton._viewPress = function() {
			    	frames['detail']._viewSegment('','',id,id2);
			    };
    			viewButton._editPress = function() {
			    	frames['detail']._editSegment('','',id,id2);
    			};
    			viewButton.attachPress(viewButton._viewPress);
        		oToolbar.addContent(
        			viewButton
        		);
        		oToolbar.addContent(
             		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.print.txt"),
    				    icon : "sap-icon://hc/print",
    				    press: function() {
    				    	frames['detail'].printVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHideUnusedButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt"),
    				    press: function() {
    				    	frames['detail'].showHideUnused();
    				    }
        		    })
        		);
        	}
        	else if (type == 'allInputClientVariables') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'EditVariableButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.editVariable.txt"),
    				    icon : "sap-icon://hc/edit",
    				    press: function() {
    				    	frames['detail'].editVariable();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteVariablesButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.deleteVariables.txt"),
    				    icon : "sap-icon://hc/delete",
    				    press: function() {
    				    	frames['detail'].deleteVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewSegmentButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.newSegment.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        enabled: false,
   				        press: function() {
   				        	frames['detail'].newSegment('','','I##',id2);
   				        }
          		    })
        		);
        		oToolbar.addContent(
             		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.print.txt"),
    				    icon : "sap-icon://hc/print",
    				    press: function() {
    				    	frames['detail'].printVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'ExportVariablesButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.exportVariables.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function() {
   				        	frames['detail'].exportVariables();
   				        }
          		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHideUnusedButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt"),
    				    press: function() {
    				    	frames['detail'].showHideUnused();
    				    }
        		    })
        		);
        	}
        	else if (type == 'outputClientVariables') {
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewVariableButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.newVariable.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function() {
   				        	frames['detail'].createVariable();
   				        }
         		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'EditVariableButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.editVariable.txt"),
    				    icon : "sap-icon://hc/edit",
    				    press: function() {
    				    	frames['detail'].editVariable();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteVariablesButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.deleteVariables.txt"),
    				    icon : "sap-icon://hc/delete",
    				    press: function() {
    				    	frames['detail'].deleteVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewSegmentButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.newSegment.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        enabled: false,
   				        press: function() {
   				        	frames['detail'].newSegment('','','O##',id2);
   				        }
          		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'ExportVariablesButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.exportVariables.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function() {
   				        	frames['detail'].exportVariables();
   				        }
          		    })
        		);
        		var viewButton = new sas.hc.m.Button({
            	    id: this.sId + 'ViewEditSegmentButton',
				    text: sas.fscf.rb.getText("variable.variableDetailMenu.viewSegment.txt"),
				    icon : "sap-icon://hc/file"
    		    });
        		viewButton._viewPress = function() {
			    	frames['detail']._viewSegment('','',id,id2);
			    };
    			viewButton._editPress = function() {
			    	frames['detail']._editSegment('','',id,id2);
    			};
    			viewButton.attachPress(viewButton._viewPress);
        		oToolbar.addContent(
        			viewButton
        		);
        		oToolbar.addContent(
             		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.print.txt"),
    				    icon : "sap-icon://hc/print",
    				    press: function() {
    				    	frames['detail'].printVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHideUnusedButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt"),
    				    press: function() {
    				    	frames['detail'].showHideUnused();
    				    }
        		    })
        		);
        	}
        	else if (type == 'allOutputClientVariables') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'EditVariableButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.editVariable.txt"),
    				    icon : "sap-icon://hc/edit",
    				    press: function() {
    				    	frames['detail'].editVariable();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteVariablesButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.deleteVariables.txt"),
    				    icon : "sap-icon://hc/delete",
    				    press: function() {
    				    	frames['detail'].deleteVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'NewSegmentButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.newSegment.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        enabled: false,
   				        press: function() {
   				        	frames['detail'].newSegment('','','O##',id2);
   				        }
          		    })
        		);
        		oToolbar.addContent(
             		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.print.txt"),
    				    icon : "sap-icon://hc/print",
    				    press: function() {
    				    	frames['detail'].printVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
           		    new sas.hc.m.Button({
                	    id: this.sId + 'ExportVariablesButton',
   				        text: sas.fscf.rb.getText("variable.variableDetailMenu.exportVariables.txt"),
   				        icon : "sap-icon://hc/newStarburst",
   				        press: function() {
   				        	frames['detail'].exportVariables();
   				        }
          		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHideUnusedButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt"),
    				    press: function() {
    				    	frames['detail'].showHideUnused();
    				    }
        		    })
        		);
        	}        	
        	else if (type == 'RUAVariables') {
        		var viewButton = new sas.hc.m.Button({
            	    id: this.sId + 'ViewEditVariableButton',
				    text: sas.fscf.rb.getText("variable.variableDetailMenu.viewVariable.txt"),
				    icon : "sap-icon://hc/file"
    		    });
        		viewButton._viewPress = function() {
			    	frames['detail'].viewVariable();
			    };
    			viewButton._editPress = function() {
    				frames['detail'].editVariable();
    			};
    			viewButton.attachPress(viewButton._viewPress);
        		oToolbar.addContent(
        			viewButton
        		);
        		oToolbar.addContent(
             		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.print.txt"),
    				    icon : "sap-icon://hc/print",
    				    press: function() {
    				    	frames['detail'].printVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHideUnusedButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt"),
    				    press: function() {
    				    	frames['detail'].showHideUnused();
    				    }
        		    })
        		);
        	}
        	else if (type == 'systemVariables') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ViewVariableButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.viewVariable.txt"),
    				    icon : "sap-icon://hc/file",
    				    press: function() {
    				    	frames['detail'].viewVariable();
    				    }
        		    })
        		);
        		oToolbar.addContent(
             		new sas.hc.m.Button({
                	    id: this.sId + 'PrintButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.print.txt"),
    				    icon : "sap-icon://hc/print",
    				    press: function() {
    				    	frames['detail'].printVariables();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'ShowHideUnusedButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt"),
    				    press: function() {
    				    	frames['detail'].showHideUnused();
    				    }
        		    })
        		);
        	}
        	else if (type == 'newVariable' || type == 'editVariable') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'SaveVariableButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.saveVariable.txt"),
    				    icon : "sap-icon://hc/save",
    				    press: function() {
    				    	frames['detail'].saveVariable();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'BackToVariableListButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.backToVariableList.txt"),
    				    icon : "sap-icon://hc/reset",
    				    press: function() {
    				    	frames['detail'].reshowVariables();
    				    }
        		    })
        		);
        	}
        	else if (type == 'viewVariable' || type == 'viewSegment') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'BackToVariableListButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.backToVariableList.txt"),
    				    icon : "sap-icon://hc/reset",
    				    press: function() {
    				    	frames['detail'].reshowVariables();
    				    }
        		    })
        		);
        	}
        	else if (type == 'newSegment' || type == 'editSegment') {
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'SaveSegmentButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.saveSegment.txt"),
    				    icon : "sap-icon://hc/save",
    				    press: function() {
    				    	frames['detail'].saveSegment();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'DeleteSegmentButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.deleteSegment.txt"),
    				    icon : "sap-icon://hc/delete",
    				    enabled: false,
    				    press: function() {
    				    	frames['detail'].deleteSegment();
    				    }
        		    })
        		);
        		oToolbar.addContent(
            		new sas.hc.m.Button({
                	    id: this.sId + 'BackToVariableListButton',
    				    text: sas.fscf.rb.getText("variable.variableDetailMenu.backToVariableList.txt"),
    				    icon : "sap-icon://hc/reset",
    				    press: function() {
    				    	frames['detail'].reshowVariables();
    				    }
        		    })
        		);
        	}
        };
        oToolbar.disableAll = function() {
        	this.getContent().forEach(function (e, i, a) {
        		e.setEnabled(false);
        	});
        };
        oToolbar.toggleShowHide = function() {
        	this.getContent().forEach(function (e, i, a) {
        		if (e.getText() == sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt")) {
        			e.setText(sas.fscf.rb.getText("variable.variableDetailMenu.showAll.txt"));
        		}
        		else if (e.getText() == sas.fscf.rb.getText("variable.variableDetailMenu.showAll.txt")) {
            		e.setText(sas.fscf.rb.getText("variable.variableDetailMenu.hideUnused.txt"));
        		}
        	});
        };
        oToolbar.enableNewSegment = function() {
        	this.getContent().forEach(function (e, i, a) {
        		if (e.getText() == sas.fscf.rb.getText("variable.variableDetailMenu.newSegment.txt")) {
        			e.setEnabled(true);
        		}
        	});
        };
        oToolbar.enableDeleteSegment = function() {
        	this.getContent().forEach(function (e, i, a) {
        		if (e.getText() == sas.fscf.rb.getText("variable.variableDetailMenu.deleteSegment.txt")) {
        			e.setEnabled(true);
        		}
        	});
        };
        oToolbar.makeSegmentEditable = function() {
        	this.getContent().forEach(function (e, i, a) {
        		if (e.getText() == sas.fscf.rb.getText("variable.variableDetailMenu.viewSegment.txt")) {
        			e.setText(sas.fscf.rb.getText("variable.variableDetailMenu.editSegment.txt"));
        			e.setIcon("sap-icon://hc/edit");
        			e.detachPress(e._viewPress);
        			e.attachPress(e._editPress);
        		}
        	});
        };
        oToolbar.makeRUAVariableEditable = function() {
        	this.getContent().forEach(function (e, i, a) {
        		if (e.getText() == sas.fscf.rb.getText("variable.variableDetailMenu.viewVariable.txt")) {
        			e.setText(sas.fscf.rb.getText("variable.variableDetailMenu.editVariable.txt"));
        			e.setIcon("sap-icon://hc/edit");
        			e.detachPress(e._viewPress);
        			e.attachPress(e._editPress);
        		}
        	});
        };
    	return oToolbar;
    }
});
