sap.ui.jsview("sas.fscf.views.RulesPageOverview", {
    getControllerName: function () {
        return "sas.fscf.views.RulesPageOverview";
    },

    createContent: function(oController) {
        jQuery.sap.require("sap.m.Toolbar");
        jQuery.sap.require("sas.hc.ui.commons.MenuButton");
        jQuery.sap.require("sas.hc.ui.unified.Menu");
        jQuery.sap.require("sas.hc.ui.unified.MenuItem");

        var tasksButton = new sas.hc.ui.commons.MenuButton({
    	    id: this.sId + 'TasksButton',
        	text: sas.fscf.rb.getText("rules.tasks.title.txt"),
        	icon : "sap-icon://hc/task",
        	tooltip: sas.fscf.rb.getText("rules.tasks.title.txt")
        });
        var busButton = new sas.hc.ui.commons.MenuButton({
    	    id: this.sId + 'BusinessUnitsButton',
        	text: sas.fscf.rb.getText("rules.businessUnits.title.txt"),
        	icon : "sap-icon://hc/usersRole",
        	tooltip: sas.fscf.rb.getText("rules.businessUnits.title.txt")
        });

        //Create the menu
        var oMenu1 = new sas.hc.ui.commons.Menu("rulesMenu1", {
        	ariaDescription: sas.fscf.rb.getText("rules.tasksMenu.txt")
        });

        //Create the items and add them to the menu
        var oMenuItem1 = new sas.hc.ui.commons.MenuItem("listRules", {
        	text: sas.fscf.rb.getText("rules.tasks.listRules.txt")
        });
        oMenu1.addItem(oMenuItem1);
        var oMenuItem2 = new sas.hc.ui.commons.MenuItem("listLookupLists", {
        	text: sas.fscf.rb.getText("rules.tasks.listLookupLists.txt")
        });
        oMenu1.addItem(oMenuItem2);
        var oMenuItem3 = new sas.hc.ui.commons.MenuItem("listVariables", {
        	text: sas.fscf.rb.getText("rules.tasks.listVariables.txt")
        });
        oMenu1.addItem(oMenuItem3);
        var oMenuItem4 = new sas.hc.ui.commons.MenuItem("listTransactions", {
        	text: sas.fscf.rb.getText("rules.tasks.listTransactions.txt")
        });
        oMenu1.addItem(oMenuItem4);
        var oMenuItem5 = new sas.hc.ui.commons.MenuItem("listActions", {
        	text: sas.fscf.rb.getText("rules.tasks.listActions.txt")
        });
        oMenu1.addItem(oMenuItem5);
        var oMenuItem6 = new sas.hc.ui.commons.MenuItem("importRules", {
        	text: sas.fscf.rb.getText("rules.tasks.importRules.txt")
        });
        oMenu1.addItem(oMenuItem6);

        //Create the second menu
        var oMenu2 = new sas.hc.ui.commons.Menu("rulesMenu2", {
        	ariaDescription: sas.fscf.rb.getText("rules.businessUnitsMenu.txt")
        });

        //The items and event handlers get dynamically created for the second menu

        //Attach the Menus to the MenuButtons
        tasksButton.setMenu(oMenu1);
        busButton.setMenu(oMenu2);

        //Attach an event to raise an alert when an item is selected.
        tasksButton.attachItemSelected(function (oEvent){
       		frames['overview'].showTaskView(oEvent.getParameter("itemId"));
        });

    	busButton.attachItemSelected(function (oEvent){
    		frames['overview'].switchBu(oEvent.mParameters.item._buId);
    	});

        //Attach the MenuButtons to the toolbar
        var oToolbar = new sap.m.Toolbar({
    	    id: this.sId + 'Toolbar',
    		content : [
    		    tasksButton,
    		    busButton
    		]
    	});

        oToolbar.removeAllBUItems = function() {
        	this.getContent()[1].getMenu().destroyItems();
        }

        oToolbar.addBUItem = function(buId, buText) {
            var buMenuItem = new sas.hc.ui.commons.MenuItem(this.sId + "BusinessUnit" + buId, {
            	text: buText
            });
            buMenuItem._buId = buId;
        	this.getContent()[1].getMenu().addItem(buMenuItem);
        }

        oToolbar.setContentFor = function(type, canModify) {
            if (canModify === undefined) {
                canModify = false;
            }
            if (!canModify){
                this.getContent()[0].getMenu().destroyItems();

                //Create the items and add them to the menu
                var oMenuItem1 = new sas.hc.ui.commons.MenuItem("listRules", {
                	text: sas.fscf.rb.getText("rules.tasks.listRules.txt")
                });
                this.getContent()[0].getMenu().addItem(oMenuItem1);
            }
        };

        return oToolbar;
    }
});
