sap.ui.jsfragment("sas.fscf.views.fragments.NewRuleDialog", {

	ruleNameLabel: null,
	ruleNameText: null,
	transactionTypeLabel: null,
	transactionTypeComboBox: null,
	transactionScopeLabel: null,
	transactionScopeSelect: null,
	businessUnitLabel: null,
	businessUnitText: null,
	operationalTimeLimitLabel:null,
	operationalTimeLimitText:null,
	//transactionSampleSelect: null,
	_bEditMode: false,
	

	createContent: function(oController) {
		this._bEditMode = sas.fscf.getCurrentPageView().jsonRule != null;
		var _this = this;
        var oDialog = new sas.hc.m.Dialog({
        	id: "newRuleDialog",
        	title: this._bEditMode ? sas.fscf.rb.getText('rules.rulesPage.editRule.txt') : sas.fscf.rb.getText('rules.rulesPage.newRule.txt'),
    	    content: [
    	               new sas.hc.ui.layout.Grid({
    	  				hSpacing: 1,
    	  				vSpacing: 1,
    	  				width: "650px",
    	  				content: [
    	  					ruleNameLabel = new sas.hc.ui.commons.Label({
    	  						id: this.sId + "ruleNameLabel",
    	  						text: sas.fscf.rb.getText('rules.rulesPage.name.txt'),
    	  						required:true,
    	  						layoutData : new sas.hc.ui.layout.GridData({
    	  							linebreakL: true,
									linebreakM: true,
									linebreakS: true,
    	  							span : "L4 M4 S4"
    	  						})
    	  					}),
    	  					ruleNameText = new sas.hc.m.Input({
    	  					 	id: this.sId + "ruleNameText",
    	  					 	value: this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.name : "",
    	  					 	required:true,
    	  						width:"350px",
    	  						layoutData : new sas.hc.ui.layout.GridData({
    	  							span : "L8 M8 S8"
    	  						})
    	  					}),
    	  					transactionTypeLabel = new sas.hc.ui.commons.Label({
    	  						id: this.sId + "transactionTypeLabel",
    	  						text: sas.fscf.rb.getText('rules.rulesPage.transactionType.txt'),
    	  						required:true,
    	  						layoutData : new sap.ui.layout.GridData({
    	  							linebreakL: true,
									linebreakM: true,
									linebreakS: true,
    	  							span : "L4 M4 S4"
    	  						})
    	  					}),
    	  					this.getTransactionTypeComboBox(frames['overview'].getContent("workingBuId")),
    	  					
    	  					transactionScopeLabel = new sas.hc.ui.commons.Label({
    	  						id: this.sId + "transactionScopeLabel",
    	  						text: sas.fscf.rb.getText('rules.rulesPage.transactionScope.txt'),
    	  						required:true,
    	  						layoutData : new sap.ui.layout.GridData({
    	  						    linebreakL: true,
    	  							linebreakM: true,
    	  							linebreakS: true,
    	  							span : "L4 M4 S4"
    	  						})
    	  					}),
    	  					this.getTransactionScopeSelect(frames['overview'].getContent("workingBuId")),
    	  					
    	  					businessUnitLabel = new sas.hc.ui.commons.Label({
    	  					    id: this.sId + "businessUnitLabel",
    	  						text: sas.fscf.rb.getText('rules.rulesPage.businessUnit.txt'),
    	  						layoutData : new sas.hc.ui.layout.GridData({
    	  							linebreakL: true,
    	  							linebreakM: true,
    	  							linebreakS: true,
    	  							span : "L4 M4 S4"
    	  						})
    	  					}),
    	  					businessUnitText = new sas.hc.m.Text({
    	  						text: frames['overview'].getContent("_buNameSelected")
    	  				    }),
    	  				    operationalTimeLimitLabel = new sas.hc.ui.commons.Label({
	    	  				    id: this.sId + "OperationalTimeLimitLabel",
	    	  					text: sas.fscf.rb.getText('rules.rulesPage.maxExecutionTime.txt'),
	    	  					required:false,
	    	  					layoutData : new sas.hc.ui.layout.GridData({
	    	  						linebreakL: true,
	    	  						linebreakM: true,
	    	  						linebreakS: true,
	    	  						span : "L4 M4 S4"
	    	  					})
    	  				    }),
    	  				    operationalTimeLimitText = new sas.hc.m.Input({
	    	  					id: this.sId + "OperationalTimeLimitText",
	    	  				 	value: this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.operationalTimeLimit : "",
	    	  				 	type: sap.m.InputType.Number,
	    	  				    allowIntegerOnly: true,
	    	  				    formatValue: false,
	    	  				 	required:false,
	    	  					width:"350px",
	    	  					layoutData : new sas.hc.ui.layout.GridData({
	    	  						span : "L8 M8 S8"
	    	  					})
    	  					
    	  				    }),
    	  				    operationalTimeLimitText.attachBrowserEvent("keydown", function(e){
	    	  					if(this._bEditMode){
	    	  						this.enableSaveButton(true);
	    	  					}
    	  				    }),
    	  				    /*transactionSampleLabel = new sas.hc.ui.commons.Label({
    	  				    	id: this.sId + "transactionSampleLabel",
    	  				    	text: sas.fscf.rb.getText('rules.rulesPage.transactionSample.txt'),
    	  				    	layoutData : new sas.hc.ui.layout.GridData({
    	  				    		linebreakL: true,
    	  				    		linebreakM: true,
    	  				    		linebreakS: true
    	  				    	})
    	  				    }),
    	  					transactionSampleSelect = new sas.hc.m.Select({
    	  						id: this.sId + "transactionSampleSelect",
    	  						layoutData : new sas.hc.ui.layout.GridData({
    	  							span : "L7 M7 S7"
    	  						}),
    	  						items: [
    	  						        new sas.hc.ui.core.Item({
    	  						          id: this.sId + "transactionSampleSelect_last24Hours",
    	  						      	  key: "last24Hours",
    	  						      	  tooltip: sas.fscf.rb.getText('rules.rulesPage.transactionSampleSelect.last24Hours.txt'),
    	  						      	  text: sas.fscf.rb.getText('rules.rulesPage.transactionSampleSelect.last24Hours.txt')
    	  						        }),
    	  						        new sas.hc.ui.core.Item({
    	  						          id: this.sId + "transactionSampleSelect_none",
    	  						      	  key: "none",
    	  						      	  tooltip: sas.fscf.rb.getText('rules.rulesPage.transactionSampleSelect.none.txt'),
    	  						      	  text: sas.fscf.rb.getText('rules.rulesPage.transactionSampleSelect.none.txt')
    	  						        }),
    	  						        ]
    	  					}),*/
    	  					ruleDescriptionLabel = new sas.hc.ui.commons.Label({
    	  						id: this.sId + "ruleDescriptionLabel",
    	  						text: sas.fscf.rb.getText('rules.rulesPage.description.txt'),
    	  						layoutData : new sap.ui.layout.GridData({
    	  							linebreakL: true,
    	  							linebreakM: true,
    	  							linebreakS: true,
    	  							span : "L4 M4 S4"
    	  						})
    	  					}),
    	  					ruleDescriptionText = new sas.hc.m.TextArea({
    	  					 	id: this.sId + "ruleDescriptionText",
    	  					 	value: this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.description : "",
    	  						width:"350px",
    	  						rows:3,
    	  						maxLength:300,
    	  						layoutData : new sas.hc.ui.layout.GridData({
    	  							span : "L8 M8 S8"
    	  						})
    	  					})
    	  				]
    	  			}),

    	    ],
    	    leftButton: new sas.hc.m.Button({
    	    	text: sas.fscf.rb.getText('rules.rulesPage.next.txt'),
    	        press: function() {
    	        	var _leftButton = this;
    	        	this.setEnabled(false);
    	        	if(ruleNameText.getValue().trim()==""){
    	        		ruleNameText.setValueState(sap.ui.core.ValueState.Error);
    	        		ruleNameText.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.guidedView.form.emptyField.error.txt"));
    	        		this.setEnabled(true);
    	        		return;
    	        	}
    	        	if(transactionTypeComboBox.getSelectedKey()==""){
    	        		transactionTypeComboBox.setValueState(sap.ui.core.ValueState.Error);
    	        		this.setEnabled(true);
    	        		return;
    	        	}
	        		var ruleId = _this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.id : "";
	        		var urlString = "";
	        		var requestType = "";
	        		var jsonRule = null;
	        		if (!_this._bEditMode) {
	        		    jsonRule = {
	        		      "id":ruleId,
		        			"name":ruleNameText.getValue(),
		        			"transactionTypeId":transactionTypeComboBox.getSelectedKey(),
		        			"multiOrgNodeId":transactionScopeSelect.getSelectedKey(),
		        			"description":ruleDescriptionText.getValue(),
		        			"operationalTimeLimit":operationalTimeLimitText.getValue(),
		        			"ruleTypeName":"Authorization",
		        			"businessUnitId":parent.frames['overview'].getContent("workingBuId"),
		        			"guidedRule":""+(sas.fscf.ruleApproach == sas.fscf.RULE_APPROACH_GUIDED)
		        		};
	        		} else {
		        		jsonRule = sas.fscf.getCurrentPageView().jsonRule;
	        			jsonRule["name"] = ruleNameText.getValue();
	        			jsonRule["transactionTypeId"] = transactionTypeComboBox.getSelectedKey();
	        			jsonRule["multiOrgNodeId"] = transactionScopeSelect.getSelectedKey();
	        			jsonRule["description"] = ruleDescriptionText.getValue();
	        			jsonRule["operationalTimeLimit"]=operationalTimeLimitText.getValue(),
	        			jsonRule["ruleTypeName"] = "Authorization";
	        		}
	        		if(ruleId=="" || ruleId==null){
	        			urlString = 'rest/businessunits/' + parent.frames['overview'].getContent("workingBuId") + '/rules/';
	        			requestType = "POST";
	        		}
	        		else{
	        			urlString = 'rest/businessunits/' + parent.frames['overview'].getContent("workingBuId") + '/rules/'+ruleId;
	        			requestType = "PUT";
	        		}
	        		sas.ajax({url:urlString, type: requestType, data: jsonRule})
	        		  .done(function(oData){
		        		jsonRule.lastUpdateNumber = oData.lastUpdateNumber;
		        		if (_this._bEditMode) {
		        			// get the rule's expressions
		        			sas.ajax({url:'rest/businessunits/'+jsonRule.businessUnitId+'/rules/'+jsonRule.id+'?fields=expressions'})
		        			  .done(function(oData){
		        			    var expressions = oData.expressions;
		        			    if (expressions) {
		        			    	jsonRule.expressions = expressions;
		        			    } else {
		        			    	jsonRule.expressions = sas.fscf.getEmptyRuleExpressions();
		        			    }
			        			jsonRule.businessUnitName = parent.frames['overview'].getContent("_buNameSelected");
		        			    _this.finishNext(jsonRule, oDialog);
		        			}).fail(function(oObj,textStatus){
		        			     console.log("failure getting rule's expressions");
			        			 _this.finishNext(jsonRule, oDialog);
		        			});
		        		} else {
		        			jsonRule.id = oData.id;
        			    	jsonRule.expressions = sas.fscf.getEmptyRuleExpressions();
		        			jsonRule.businessUnitName = parent.frames['overview'].getContent("_buNameSelected");
	        			    _this.finishNext(jsonRule, oDialog);
		        		}

	        		 }).fail(function(oObj,textStatus,errorThrown){
	        			 if(errorThrown == "Conflict"){
	        				 sas.fscf.showInlineMessage(oDialog.sId + "-scrollCont", sas.fscf.MESSAGE_TYPE_ERROR, sas.fscf.rb.getText('rules.rulesPage.guidedView.cannotEditEditedElsewhere.txt'));
	        			 } else if (oObj.responseJSON.message) {
	        				 sas.fscf.showInlineMessage(oDialog.sId + "-scrollCont", sas.fscf.MESSAGE_TYPE_ERROR, oObj.responseJSON.message);
	        			 } else {
	        				 sas.fscf.showInlineMessage(oDialog.sId + "-scrollCont", sas.fscf.MESSAGE_TYPE_ERROR, sas.fscf.rb.getText('rules.rulesPage.guidedView.errorSavingRule.txt'));
	        			 }
	        	         _leftButton.setEnabled(true);
	        		});
    	        }
    	    }),
    	    rightButton:  new sas.hc.m.Button({
    	    	text: sas.fscf.rb.getText('rules.rulesPage.cancel.txt'),
    	        press: function() {
    	        	oDialog.close();
    	        }
    	    })
        });

        ruleNameText.attachBrowserEvent("keypress", function(e) {
        	var key_codes = [35,37,38,44,60,62];
			if ($.inArray(e.which, key_codes) >= 0) {
				e.preventDefault();
				ruleNameText.setValueState(sap.ui.core.ValueState.Error);
        		ruleNameText.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.specialCharacters.error.txt"));
			}
        });

        ruleNameText.attachBrowserEvent("paste", function(e) {
        	var text = window.clipboardData.getData('text');
        	if(text.indexOf("#") != -1 || text.indexOf("%") != -1 || text.indexOf("&") != -1 || text.indexOf("<") != -1 || text.indexOf(">") != -1 || text.indexOf(",") != -1){
        		e.preventDefault();
        		ruleNameText.setValueState(sap.ui.core.ValueState.Error);
        		ruleNameText.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.specialCharacters.error.txt"));
        	}
        });
        
        oDialog.attachAfterClose(function(oEvent) {
        	_this.transactionTypeComboBox = null;
        	_this.transactionScopeSelect = null;
        	_this.operationalTimeLimitLabel=null;
        	//_this.transactionSampleSelect = null;
        	this.destroy();
        });

        return oDialog;
    },

    finishNext: function(jsonRule, oDialog) {
  		sas.fscf.getCurrentPageView().jsonRule = jsonRule;
  		if (this._bEditMode) {
  			sas.fscf.getCurrentPageView().initIdsForExpressions("F", sas.fscf.getCurrentPageView().jsonRule.expressions.expressions[0].condition.expressions);
  		}
    	if (sas.fscf.ruleApproach == sas.fscf.RULE_APPROACH_GUIDED) {
    		sas.fscf.getCurrentPageView().switchToGuidedContent();
    	} else {
    		sas.fscf.getCurrentPageView().switchToCodingContent();
    	}
    	oDialog.close();
		if (this._bEditMode) {
        	if (sas.fscf.ruleApproach == sas.fscf.RULE_APPROACH_GUIDED) {
        		sas.fscf.loadRule(sas.fscf.getCurrentPageView().getGuidedView());
        	} else {
        		sas.fscf.loadRule(sas.fscf.getCurrentPageView().getCodingView());
        	}
		} else {
			// If it's a new rule and TAS is not installed and configured, then
			// start the guided view in form mode
			if (!sas.fscf.ruleEnableGuided) {
	        	if (sas.fscf.ruleApproach == sas.fscf.RULE_APPROACH_GUIDED) {
	        		sas.fscf.startInFormView(sas.fscf.getCurrentPageView().getGuidedView());
	        	}				
			}
		}
    },

    getTransactionScopeSelect: function(buId){
    	var transactionScopeModel = new sap.ui.model.json.JSONModel("rest/multiorgs?businessUnit="+buId);
    	transactionScopeModel.setSizeLimit(100000);    	
    	transactionScopeSelect = new sas.hc.m.Select({
    		selectedKey : this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.multiOrgNodeId : "",
    		width : "350px",
    		layoutData : new sas.hc.ui.layout.GridData({
    			span : "L8 M8 S8"
    		})
    	});
    	transactionScopeSelect.bindAggregation("items", "/items", new sas.hc.ui.core.ListItem({key:"{id}",text:"{displayName}"}));
    	transactionScopeSelect.setModel(transactionScopeModel);
    	return transactionScopeSelect;
    },

    getTransactionTypeComboBox: function(buId){
    	jQuery.sap.require("sap.ui.model.Sorter");
    	var transactionTypesModel = new sap.ui.model.json.JSONModel("rest/businessunits/"+buId+"/transactiontypes?type=stock");
    	transactionTypesModel.setSizeLimit(100000);    			
    	transactionTypeComboBox = new sas.hc.ui.commons.ComboBox({
    		selectedKey : this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.transactionTypeId : "",
    		width : "350px",
    		layoutData : new sas.hc.ui.layout.GridData({
    			span : "L8 M8 S8"
    		})
    	});    	
    	
    	// control is missing getSelectedItem function, so add it
    	transactionTypeComboBox.getSelectedItem = function() {
    		return sap.ui.getCore().byId(this.getSelectedItemId());
    	};
    	transactionTypeComboBox.bindAggregation("items", {
            path: "/items",
            factory: function(sId, oContext) {
                  return new sas.hc.ui.core.ListItem(sId, {
                        key: oContext.getProperty("id"),
                        text: oContext.getProperty("displayName")
                  });
            },
            sorter: new sap.ui.model.Sorter("description")
        });

    	transactionTypeComboBox.setModel(transactionTypesModel);	
		if(!this._bEditMode){
    		var selectTransactionTypeText = new sap.ui.core.ListItem("chooseTransactionTypeText", {
    		    text : sas.fscf.rb.getText("rules.rulesPage.selectTransactionType.txt")
    		});
    		transactionTypeComboBox.addItem(selectTransactionTypeText);
    		transactionTypeComboBox.setSelectedItemId("chooseTransactionTypeText");
    	}
    	transactionTypeComboBox.attachLiveChange(function (oEvent) {
    		transactionTypeComboBox.setValueState(sap.ui.core.ValueState.None);
        });    	
    	return transactionTypeComboBox;
    }
});
