<!DOCTYPE html>

<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<html>

<head>
   <meta http-equiv="X-UA-Compatible" content="IE=edge">
   <title>
<c:choose>
	<c:when test="${empty productName}">
		SAS&reg; Fraud Management
	</c:when>
	<c:otherwise>
		${fn:replace(fn:replace(productName, "<sup>", ""), "</sup>", "")}
	</c:otherwise>
</c:choose>
	 - <fmt:message key="rules.rulesImport.pageTitle.txt" />
	</title>
   <style type='text/css'>@import 'common/styles/sasStyles.css';</style><link rel='stylesheet' href='rules/styles/rules.css' type='text/css'>  <link rel='stylesheet' href='common/styles/cf.css' type='text/css'>  <style type='text/css'>@import 'admin/styles/admin.css';</style>
   <script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
   <script language="JavaScript" src="rules/scripts/itemPriorityList.js"></script>
   <script language="JavaScript" src="rules/scripts/autoSizing.js"></script>
   <SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
   <SCRIPT language="JavaScript" src="common/scripts/sasSolutions.js"></SCRIPT>
   <SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>
   <script language="JavaScript" src="rules/scripts/rules.js"></script>
   <script language="JavaScript" src="rules/scripts/ruleSasTest.js"></script>
   <script>
      var workflow = "";
      function importOnloadHandler()
      {
           rulesTabOnLoadHandler();
           var theOpener = (window.opener) ? window.opener : window.dialogArguments;
    	   var detail = theOpener.parent.frames['detail'];
    	   if (detail){
    		   var loc = detail.location.href.substring(0, detail.location.href.indexOf('?'));
    		   var reloadURL = (loc!="" ? loc : detail.location.href) + detail.reloadParams;
    		   detail.location.href = reloadURL;
    	   }
      }
   </script>
</head>

<body onload="importOnloadHandler()">

<form name="printableForm" style="display:none">
   <input type="hidden" id="printableVersionTitle"/>
   <input type="hidden" id="printableVersionTableId"/>
</form>


   <%-- Error handling code --%>
   <div onclick="this.innerHTML='<br>'">
     <c:url var="reloadURL" value="/r_rules.do?method=listRules&ruleFolder=Coding&showAll=true" />
     <tiles:insert page="rulesSystemMessages.jsp" flush="true">
       <tiles:put name="reloadURL" value="${reloadURL}" />
       <tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
       <tiles:put name="objectTypeName" value="Rule" />
     </tiles:insert>
   </div>


   <div id="importResultsTitle" align="left" style="font-size:10pt;margin:0px 0px 0px 8px;color:#353535;font-weight:bold;width:95%;">
      <input type="button" value="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleImportResults.button.close.txt'/></esapi:encodeForHTMLAttribute>" class="button" style="text-align:center;width:8em;float:right;margin-right:8px;" onclick="window.close()">
      <div><fmt:message key='rules.ruleImportResults.table.title.txt' /> <image src="images/rules/printer.gif" title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleImportResults.viewPrintableVersion.title.txt'/></esapi:encodeForHTMLAttribute>" onclick="printOpenerTable('<esapi:encodeForJavaScript><fmt:message key='rules.ruleImportResults.table.title.txt' /></esapi:encodeForJavaScript>','ruleListTable')" /></div>
   </div>
   <br>

   <div>
   <br>

   <table class="mainTable" id="ruleListTable" width="95%" align="center" style="margin:0px 0px 0px 0px;-moz-user-select:none;" onselectstart="return false;" border="0" cellspacing="0" cellpadding="0">
      <thead>
          <TR class="tableColumnHeaderRow">
             <TH class="centeredTableHeader" nowrap rules:sortAsLocalDate title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleImportResults.tableHeader.time.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key='rules.ruleImportResults.tableHeader.time.txt' /></TH>
             <TH class="centeredTableHeader" nowrap rules:sortAsText title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleImportResults.tableHeader.name.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key='rules.ruleImportResults.tableHeader.name.txt' /></TH>
             <TH class="centeredTableHeader" nowrap rules:sortAsText title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleImportResults.tableHeader.type.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key='rules.ruleImportResults.tableHeader.type.txt' /></TH>
             <TH class="centeredTableHeader" nowrap rules:sortAsText title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleImportResults.tableHeader.message.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key='rules.ruleImportResults.tableHeader.message.txt' /></TH>
          </TR>
      </thead>
      <TBODY id="ruleTableBody">
         <c:choose>
         <c:when test="${empty importees}">
           <TR rowspan="2">
              <TD align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key='rules.ruleBuildAction.nothingImported.txt'/></center></em></TD>
           </TR>
         </c:when>
         <c:otherwise>
           <c:forEach var="importee" items="${importees}" varStatus="status">
           <TR id="${status.count}" class="dataRow${status.count%2+1}_tableRow">
               <TD class="textTableCell" >&nbsp;<span sortValue="<%= System.currentTimeMillis()%>"></span></TD>
               <TD class="textTableCell">&nbsp;${fn:escapeXml(importee.name)} <%-- S0881932 --%>
                 <c:if test="${importee.messageCount>1}">&nbsp;[${importee.messageNumber}/${importee.messageCount}]</c:if>
               </TD>
               <TD class="textTableCell" nowrap>&nbsp;${importee.type} </TD>
               <TD class="textTableCell">&nbsp;${fn:escapeXml(importee.message)}</TD> <%-- S0881932 --%>
            </TR>
           </c:forEach>
         </c:otherwise>
         </c:choose>
      </TBODY>
   </table>

   </div>

   </div>

 <script>
   attachEventHandlerToTableCells(['ruleListTable']);
 </script>

</body>
</html>
