<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
   <style type="text/css">@import "common/styles/sasStyles.css";</style>
   <style type="text/css">@import "includes/view.css";</style>
   <script language='JavaScript' src='common/scripts/i18n.js'></script>
   <script language="JavaScript" src="includes/view.js"></script>
   <script language="JavaScript" src="common/scripts/tree.js"></script>
   <script language="JavaScript" src="rules/scripts/rules.js"></script>
   <script language="JavaScript" src="rules/scripts/tasks.js"></script>
   <script language="JavaScript" src="rules/scripts/estimate.js"></script>

<tiles:insert page="/rules/rulesOverviewInitToolbar.jsp"/>

<!-- Tree header. -->
<div class="sapUiTreeHeader" id="rulesHeader" role="heading">
  <div class="sapUiTreeTitle"><fmt:message key="rules.listRules.title.txt" /> : ${_buNameSelected}</div>
</div>

<input type="hidden" id="workingBuId" name="workingBuId" value="${workingBuId}">
<input type="hidden" id="_buNameSelected" name="_buNameSelected" value="${_buNameSelected}">
<input type="hidden" id="isDevEnv" name="isDevEnv" value="${isDevEnv}">
<c:forEach var="user" items="${ruleWriters}" varStatus="status">
  <input type="hidden" id="_userName" name="_userName" value="${fn:trim(fn:escapeXml(user.username))}">
</c:forEach>

<!-- Nested tables with fixed height -->
<table id="overview_table" cellspacing=0 cellpadding=2 border="0"  >
   <tr>
      <td id="navcol" align="left" valign="top" nowrap>

<script language="JavaScript">
//<!--
   var _canModify = false;
   <c:if test="${empty updtRules || updtRules}">
        _canModify = true;
   </c:if>
// alert(_canModify);
   parent.sas.fscf.getCurrentOverviewToolbar().setContentFor('any', _canModify);

   // CheatSheet: function Node( nodeId, parentId, image, title, tip, parameters, state, italic, owner )

   function getContent(value){
	  var element = document.getElementById(value).value;
	  return element;
   }
   // Remove padding so menubar appears to be glued to the top
   document.body.style.padding = "0";

   var _workingBuId = '${workingBuId}';
   var _mustRequestApprovalToPromote = ${not empty pwaRules && !pwaRules};
   var _mustRequestApprovalToDeactivate = ${not empty dwaRules && !dwaRules};

   // store estimate counts
   var userEstimateCnt = new Array();
   // initialize map
   <c:forEach var="user" items="${ruleWriters}" varStatus="status">
      userEstimateCnt['${fn:trim(fn:escapeXml(user.username))}'] = 0;
   </c:forEach>
   <c:forEach var="item" items="${estimateCount}" >
      userEstimateCnt['${fn:trim(fn:escapeXml(item.key))}'] = ${item.value};
   </c:forEach>

   // store rule counts
   var userRuleCnt = new Array();
   // initialize map
   userRuleCnt['STATE:Coding'] = 0;
   userRuleCnt['STATE:Testing'] = 0;
   userRuleCnt['STATE:Production'] = 0;
   userRuleCnt['STATE:Deactivated'] = 0;
   userRuleCnt['STATE:Trash'] = 0;
   <c:forEach var="user" items="${ruleWriters}" varStatus="status">
      userRuleCnt['${fn:trim(fn:escapeXml(user.username))}'] = 0;
   </c:forEach>
   <c:forEach var="item" items="${ruleCount}" >
      userRuleCnt['${fn:trim(fn:escapeXml(item.key))}'] = ${item.value};
   </c:forEach>

   // Rule folder Nodes
   var _folderNodes = new Array();
   // A rule folder has no parent so parent id is 0
   // this is the startnode value when the tree is created
   _params = new Array();
   // static folders
   // look at tree.js for api
   _folderNodes[_folderNodes.length] = new Node("root", 0, "folder", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.rules.txt' /></esapi:encodeForHTMLAttribute>",
   		"<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.rules.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
   _folderNodes[_folderNodes.length] = new Node("Coding", "root", "folder", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.coding.txt' /></esapi:encodeForHTMLAttribute>",
   		"<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.coding.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");

   // all coding rules node
   _folderNodes[_folderNodes.length] = new Node("allCoding", "Coding", "Code", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.allRules.txt' /></esapi:encodeForHTMLAttribute> ["+userRuleCnt['STATE:Coding']+"]",
   		"<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.allRules.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
   // by user
   <c:forEach var="user" items="${ruleWriters}" varStatus="status">
   _folderNodes[_folderNodes.length] = new Node("${esapi:encodeForJavaScript(user.username)}", "Coding", "Code",
            "${fn:trim(fn:escapeXml(user.lastName))}, ${fn:trim(fn:escapeXml(user.firstName))} (${fn:trim(fn:escapeXml(user.username))})" + " [" + userRuleCnt['${fn:trim(fn:escapeXml(user.username))}'] + "]",
            "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.ruleWriter.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
   </c:forEach>

   _folderNodes[_folderNodes.length] = new Node("Testing", "root", "PerformanceMonitor", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.testing.txt' /></esapi:encodeForHTMLAttribute> ["+userRuleCnt['STATE:Testing']+"]",
   		"<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.testing.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
   _folderNodes[_folderNodes.length] = new Node("Production", "root", "DeployedJob", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.production.txt' /></esapi:encodeForHTMLAttribute> ["+userRuleCnt['STATE:Production']+"]",
   		"<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.production.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
   _folderNodes[_folderNodes.length] = new Node("Deactivated", "root", "deactivate", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.deactivated.txt' /></esapi:encodeForHTMLAttribute> ["+userRuleCnt['STATE:Deactivated']+"]",
   		"<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.deactivated.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
   _folderNodes[_folderNodes.length] = new Node("Trash", "root", "delete", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.trash.txt' /></esapi:encodeForHTMLAttribute> ["+userRuleCnt['STATE:Trash']+"]",
   		"<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.trash.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");

  <c:if test="${empty updtRules || updtRules}">
        _folderNodes[_folderNodes.length] = new Node("Estimations", 0, "folder", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.estimations.txt' /></esapi:encodeForHTMLAttribute>",
   		   "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.estimations.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
        // all estimates node
         _folderNodes[_folderNodes.length] = new Node("ESTIMATION_USER_allEstimates", "Estimations", "File", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.allEstimations.txt' /></esapi:encodeForHTMLAttribute> [${estimateCount.all}]",
   		   "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.allEstimations.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
        // by user
        <c:forEach var="user" items="${ruleWriters}" varStatus="status">
            _folderNodes[_folderNodes.length] = new Node('ESTIMATION_USER_${fn:escapeXml(user.username)}', "Estimations", "File",
            "${fn:trim(fn:escapeXml(user.lastName))}, ${fn:trim(fn:escapeXml(user.firstName))} (${fn:trim(fn:escapeXml(user.username))})" + " [" + userEstimateCnt['${fn:trim(fn:escapeXml(user.username))}'] + "]",
            "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.ruleWriter.title.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
        </c:forEach>
  </c:if>

   _folderNodes[_folderNodes.length] = new Node("Deployments", 0, "folder", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.deployments.txt' /></esapi:encodeForHTMLAttribute>", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.deployments.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
   _folderNodes[_folderNodes.length] = new Node("Current", "Deployments", "DeployedJob", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.diagnostic.availableForDeployment.txt'/></esapi:encodeForHTMLAttribute>", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.diagnostic.availableForDeployment.txt'/></esapi:encodeForHTMLAttribute>", _params, "", "", "");
   <!--active deployment-->
   var _canEnableDisable = false;
   <c:if test="${(empty disenaRules || disenaRules) && canEnableDisable=='true'}">
        _canEnableDisable = true;
   </c:if>   
   _folderNodes[_folderNodes.length] = new Node("Active", "Deployments", "RunningPerson", "<fmt:message key='rules.ruleListOverviewContent.activeDeployment.txt'/>", "<fmt:message key='rules.ruleListOverviewContent.activeDeployment.txt'/>", _params, "", "", "");
   

   //_folderNodes[_folderNodes.length] = new Node("Current", "Deployments", "DeployedJob", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.current.txt' /></esapi:encodeForHTMLAttribute>", "<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListOverviewContent.current.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
	<c:forEach var="builds" items="${builds}" varStatus="status">
		_folderNodes[_folderNodes.length] = new Node("build${builds.buildID}", "Deployments", "Code", "<fmt:formatDate value='${builds.createTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/> (<fmt:message key='rules.diagnostic.build.txt'/> ${builds.buildID})", "<fmt:formatDate value='${builds.createTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/> (<fmt:message key='rules.diagnostic.build.txt'/> ${builds.buildID})", _params, "", "", "");
	</c:forEach>

   var _isSomethingSelected = false;
   // For new and modified actions show the selected node

   // Select previously selected node, or the logged in rule writer's folder by default
   var _selectedObject = getCookieForTab("-1");
   var _openNodes = "Coding";

   // select the workflow folder
   // for coding workflows we also need to select a playpen view if required
   <c:if test = "${!empty workflow}">
      _openNodes = '${workflow}';
      <c:choose>
         <c:when test="${workflow == 'Coding'}">
            <c:choose>
            	<c:when test="${(empty rules_view) || (rules_view == 'all' )}">
            	  	if (_selectedObject == "-1") _selectedObject = "allCoding";
            	</c:when>
            	<c:otherwise>
               		if (_selectedObject == "-1") _selectedObject = '${fn:escapeXml(sessionScope.PRINCIPAL.username)}';
            	</c:otherwise>
         	</c:choose>
         </c:when>
         <c:when test="${workflow=='build'}">
            if (_selectedObject == "-1") _selectedObject='build${buildID}';
         </c:when>
         <c:otherwise>
            if (_selectedObject == "-1") _selectedObject = '${workflow}';
         </c:otherwise>
   </c:choose>
   </c:if>

   var ruleDetailAction = '<c:url value="/r_rules.do"/>' ;
   var estimateDetailAction = '<c:url value="/r_ruleEstimates.do"/>' ;

   // Currently making the parent open does not expand the tree if the parent is not at the top level
   // All ancestors must be added to the open node list for this to work (Coding
   _rulesFolderTree = new Tree("_rulesFolderTree", _folderNodes, 0, "root|Coding|Deployments|Estimations", _selectedObject, "showRules(ruleDetailAction, estimateDetailAction);",
                         false, false, true, "common/images/tree/", "images/rules/" );

   // show rules for the selected folder
   <c:if test="${refresh != 'true'}">
      // alert(${refresh} +','+ ruleDetailAction +','+ estimateDetailAction); // S0838078
      showRules(ruleDetailAction, estimateDetailAction);
   </c:if>
//-->
</script>
<span style="cursor:pointer;" onclick="alert('Version:\t<%= com.sas.finserv.creditfraud.rules.service.RuleAbstractTest.WEBAPP_VERSION %>\nBuild:\t<%= com.sas.finserv.creditfraud.rules.service.RulesServiceImpl.CVS_BUILD_INFO %>')">&nbsp;&nbsp;
&nbsp;&nbsp;</span>

 </td>
 </tr>
</table>