<%/*--------------------------------------------------------------------------------------|
|Copyright (c) 2007, SAS Institute, Inc.  All Rights Reserved.
|
|NAME: rules/rulePrintableVersion.jsp
|DESCRIPTION: JSP page to print a rule definition from the rules editor (it fills in values
|             in the standard rule-printing template from the opener using Javascript)
|---------------------------------------------------------------------------------------*/%>
<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<HTML>

<HEAD>
 <TITLE>
 <c:choose>
	<c:when test="${empty productName}">
		SAS&reg; Fraud Management
	</c:when>
	<c:otherwise>
		${fn:replace(fn:replace(productName, "<sup>", ""), "</sup>", "")}
	</c:otherwise>
 </c:choose>
 </TITLE>

<STYLE>
  TD {font-family: helvetica,ariel,sans-serif;
      vertical-align: top;
      color: black;
      font-size: x-small;
     }
  </STYLE>
</HEAD>



<BODY marginheight="0" marginwidth="0" onload="getValuesFromOpener()">

<c:set var="noRuleInfo"><fmt:message key="rules.printRule.noRuleInfo.txt" /></c:set>
<c:set var="noneValue"><fmt:message key="rules.printRule.noneValue.txt" /></c:set>

<SCRIPT language="JavaScript">
//<!--

// Locations in the opener of this page to copy information from
var theOpener;
var opForm;
var opDoc;
var NONE = "<span class='softNone'>${esapi:encodeForJavaScript(noneValue)}</span>";

// Convert <> etc. to escaped values S0881932
function escapeHtml( string )
{
    var pre = document.createElement('pre');
    var text = document.createTextNode( string );
    pre.appendChild(text);
    return pre.innerHTML;
}
function setInnerHTML(id, newValue)
{
  var opTag = document.getElementById(id);
 
  if (!opTag || !opTag.innerHTML)
     return;
  opTag.innerHTML = newValue;
}
function getInnerHTML(id)
{
  var opTag = opDoc.getElementById(id);
  if (!opTag || !opTag.innerHTML)
     return "";
  if (opTag.innerHTML.replace(/^\s*|\s*$/g,"") != "") {
     return opTag.innerHTML;
  }
  else {
     return "";
  }
}
// Copy the innerHtml from one page to another
function copyInnerHTML(id, prefix, suffix, noneText, escaping) // S0881932
{
  if (! prefix) prefix = " ";
  if (! suffix) suffix = " ";
  if (! noneText) noneText = NONE;
  var opTag = opDoc.getElementById(id);
  if (!opTag || !opTag.innerHTML)
     return;
  if ((opTag.innerHTML.replace(/^\s*|\s*$/g,"")=='' || opTag.innerHTML.toLowerCase().indexOf(NONE.toLowerCase()) >= 0))
     document.getElementById(id).innerHTML = noneText;
  else if (opTag.innerHTML.replace(/^\s*|\s*$/g,"") != "")
     document.getElementById(id).innerHTML = prefix + (escaping ? escapeHtml(opTag.innerHTML) : opTag.innerHTML) + suffix; // S0881932
   else
     document.getElementById(id).innerHTML = noneText;
}

// Copy the value of a form tag from one page to another
function copyFormValue(name, escaping) // S0881932
{
  var opTag = eval('opForm.' + name);
  if (opTag && opTag.value && opTag.value.replace(/^\s*|\s*$/g,"") != "")
     document.getElementById(name).innerHTML = (escaping ? escapeHtml(opTag.value) : opTag.value); // S0881932
  else
     document.getElementById(name).innerHTML = NONE;
}

// Copy selected option for fields that are selectors
function copySelection(id, targetId, alternateNone)
{
  if (! targetId) targetId = id;
  var opTag = opDoc.getElementById(id);
  if (opTag &&
      opTag.selectedIndex &&
      opTag.selectedIndex != 0 &&
      opTag.options &&
      opTag.options[opTag.selectedIndex] &&
      opTag.options[opTag.selectedIndex].innerHTML &&
      opTag.options[opTag.selectedIndex].innerHTML.replace(/^\s*|\s*$/g,"") != "")
    document.getElementById(targetId).innerHTML = opTag.options[opTag.selectedIndex].innerHTML;
  else if (alternateNone)
    document.getElementById(targetId).innerHTML = alternateNone;
  else
    document.getElementById(targetId).innerHTML = NONE;
}

// Hide selected value                                          // S0750302
function hideValue(valueId, labelId)                            // S0750302
{                                                               // S0750302
  document.getElementById(valueId).style.visibility = "hidden"; // S0750302
  document.getElementById(labelId).style.visibility = "hidden"; // S0750302
}                                                               // S0750302

function getValuesFromOpener()
{
   // Copy rule values from the opener to this window
  theOpener = window.opener;
  if (theOpener)
  {
    
    opDoc = theOpener.document;
    opForm = opDoc.getElementById("ruleForm");

    copyInnerHTML('createdInfo');
    copyInnerHTML('updatedInfo');
    copyInnerHTML('ruleBusinessUnitInfo');
    copyInnerHTML('usedVariablesForDisplay');
    copyInnerHTML('preRequisitesForDisplay','','',' ');
    copyInnerHTML('dependencySeparator','','',' ');
    copyInnerHTML('weakRequisitesForDisplay','','',' ');    
    copyInnerHTML('code', '<pre>', '</pre>');

    copyFormValue('name', true);        // S0881932
    copyFormValue('description', true); // S0881932
    copyFormValue('operationalTimeLimit', true); 
    copyFormValue('alertReason', true); // S0881932

    copySelection('multiOrgId');
    if (opForm.enableXAMS.value == '')      // S0750302
        copySelection('queueId');
    else                                    // S0750302
        hideValue('queueId','queueLabel');  // S0750302
    copySelection('alertType');
    copySelection('transactionId','transactionType',"<i><esapi:encodeForJavaScript><fmt:message key='rules.rulesPrintableVersion.value.custom.txt'/></esapi:encodeForJavaScript></i>");

    // Rule type is a selector for new rules and a string for old ones
    if (opDoc.getElementById('ruleTypeIdSelector'))
       copySelection('ruleTypeIdSelector','ruleTypeInfo');
    else
       copyInnerHTML('ruleTypeInfo');

    // Execution order
    var xeqOrd = opDoc.getElementById("executionOrderType");
    document.getElementById("executionOrderInfo").innerHTML = xeqOrd[xeqOrd.selectedIndex].innerHTML +
       (xeqOrd.selectedIndex!=1 ? " <esapi:encodeForJavaScript><fmt:message key="rules.printRule.priority.txt" /></esapi:encodeForJavaScript> " + opDoc.getElementById("executionOrderPriority").value : "");

    // Label the output clearly
    <%-- var theProduct = "SAS Fraud Management"; --%>
	var noRuleName = "<esapi:encodeForJavaScript><fmt:message key="rules.printRule.noneValue.txt" /></esapi:encodeForJavaScript>";
    var theBaseRuleIdInfo = opDoc.getElementById('baseRuleIdInfo').innerHTML.split(".")[0];
    var theNameElement = document.getElementById('name').innerHTML.replace(/&nbsp;/g,"");
    if (document.getElementById('name').childNodes[0].innerHTML === noRuleName) { //S1186832
    	theNameElement = noRuleName;
    }
    
    setInnerHTML('ruleFormattedId', theOpener.$i18n("rules.printRule.rule.fmt.txt", [getInnerHTML('ruleTypeInfo'), getInnerHTML('baseRuleIdInfo')]));

    var theTitle = "<esapi:encodeForJavaScript><fmt:message key="rules.printRule.rule.txt" /></esapi:encodeForJavaScript> " + theBaseRuleIdInfo + ": " + theNameElement;
    document.title = document.title + " - " + theTitle;
  }
  else
  {
  	var msg = "${esapi:encodeForJavaScript(noRuleInfo)}";
    alert(msg);
  }
}

//-->
</SCRIPT>


<%-- Include common print layout (used here as well as in rulesPrintableVersion.jsp for rule lists) --%>
<%@ include file="/rules/tiles/printRule.jsp" %>



</BODY>
</HTML>


