function exportPDF()
{
   document.forms.ruleData.ec_eti.value='ruleData';
   document.forms.ruleData.ruleData_ev.value='pdfRulesList';
   document.forms.ruleData.ruleData_efn.value='rules.pdf';
   document.forms.ruleData.setAttribute('action','r_rules.do');
   document.forms.ruleData.setAttribute('method','post');
   document.forms.ruleData.submit();

}


// Does processing needed upon completion of page load for Rules (and other) tab screens (both list screens and rule detail popup)
function rulesTabOnLoadHandler()
{
  if (window.removeBusy) removeBusy();

  // Adjust datetimes to local from GMT
  //adjustDatetimes(); //S1162407

  // Use alternate onload processing for Console tab Activity display
  if (window.displayedBars) {
    consoleTabOnLoadHandler();
    return;
  }


  // Use alternate onload processing for morgTran screen
  if (document.getElementById("morgTransTable")) {
    morgTranOnLoadHandler();
    return;
  }


  // Establish the onResize handler for popup
  try {
	  if (opener && opener.window && opener.window.name == "detail")
	  {
		  window.onresize = rulesTabPopupResizeHandler;
		  rulesTabPopupResizeHandler();
	  }
  } catch (error) {
      // If opening frame moves away from original rule list, we get an exception
	  window.onresize = rulesTabPopupResizeHandler;
	  rulesTabPopupResizeHandler();
  }
  // Establish the onResize handler (complain immediately if someone else is using it)
//  if (window.onresize && window.onresize != rulesTabResizeHandler)
//    alert($i18n("rules.ruleAction.js.rulesTabResizeHandler.fmt.txt", [window.onresize]));
//  else
//    window.onresize = rulesTabResizeHandler;
//  rulesTabResizeHandler();

  // These functions work in both list screen and detail popup (no-op when non-applicable)
  try {
    buildSelectors();
    enableButtons();
  } catch(e) {
    // alert('caught ' + e.description);
    return;
  }

  // Enable drag and drop (if present)
  if (window.draggableIcons && window.draggableIcons.each)
  {
    draggableIcons.each( function(item) {
       new Draggable(item, { revert:true, ghosting:true });
    } );
    Droppables.add('canvas', { hoverclass: 'hoverActive', onDrop: dropIcon, onHover: inFlight } );
  }

  // Show propeties tab initially if defined
  if (window.swapGridContents)
  {
    swapGridContents('codeBuilder',1); // Droppable canvas must initialize before hiding it
    swapGridContents('ruleProperties',1);
    resizeProperties();
    changeExecutionPrioritySelector();
    document.body.style.backgroundColor = '#f0f1f2';

    // Reflect rule in title
    if (document.ruleForm  && document.ruleForm.baseRuleId && document.ruleForm.name && document.getElementById('ruleTypeInfo')) {
        var rt = '';
        if (document.getElementById('isTenantInstall').value == 'false')
            rt = '(' + document.getElementById('ruleTypeInfo').innerHTML.replace(/^\s*|\s*$/g,"") + ')';
      //document.title = "Rule " + document.ruleForm.baseRuleId.value + ": " + rt + " " + document.ruleForm.name.value; //pcs
      document.title = $i18n("rules.listRules.title.txt") + " " + document.ruleForm.baseRuleId.value + ": " + rt + " " + document.ruleForm.name.value;
    }
  }

  // Set shift-space indicator
  try { setIgnoreShiftSpace(document.ruleForm && document.ruleForm.ignoreShiftSpaceInd && document.ruleForm.ignoreShiftSpaceInd.value=='1'); } // S0844689
  catch (error) { } // Ignore

  // Show/hide rows if creating an estimate
  if (window.initializeEstimationCreator) initializeEstimationCreator();
}

// Drop an icon onto the canvas for the codebuilder
function dropIcon(draggable, canvas)
{
  alert('dropped icon ' + draggable + " onto " + canvas);
}

// Show where we are when dragging
function inFlight(draggable, droppable, position) {
  $('canvas').innerHTML = new Date().toString() + "<br>" + droppable.getStyle('background-color') + "<br>" + droppable.className;
}

function refreshRuleFolders(action) {
	let locHref = action + "?method=listRuleFolders&refresh=true&workflow=" + workflow;
	if (typeof buildID != "undefined") {
		locHref += "&buildID=" + buildID;
	}
	parent.frames[ "overview" ].location.href = locHref;
}

function showRules(ruleAction,estAction) {
	setBusyDetail();
	var selectedNodes = _rulesFolderTree.getSelectedNodes();
	// If the current signed-in user is different from the previous user, and the previous user had selected his own
	// rules folder, selectedNodes is empty, because the system is unable to reselect that user's folder. In such cases,
	// default to the allCoding folder.
	if (selectedNodes.length === 0) {
		_rulesFolderTree.setSelectedIds("allCoding");
		selectedNodes = _rulesFolderTree.getSelectedNodes();
	}
	var node = selectedNodes[0];
	var nodeId = node.getId();

	if(nodeId == "root") {
		nodeId = "allCoding";
	}

	if (nodeId == "Estimations") {
		nodeId = "ESTIMATION_USER_allEstimates";
	}
	if (nodeId.indexOf("ESTIMATION_USER") == 0) {
		showRuleEstimates(estAction,nodeId);
		return;
	}
	
	setCookie("rules_folders", nodeId);
	setCookieForTab(nodeId);

	// Special handling for coding rules
	if(nodeId == "Coding") {
		nodeId = "allCoding";
	}
	var userId = "";
	if(nodeId == "allCoding") {   // all coding rules
		nodeId = "Coding";
	} else if(node.parentId == "Coding") { // coding rules by user
		nodeId = "Coding";
		userId = node.getId();
	}
	if(nodeId != "") {
		if(nodeId.substring(0,5) == "build"){
			var buildID=nodeId.replace("build", "");
			nodeId='build';
		}
	}
	if((nodeId =="Deployments") || (nodeId == "Current")) {
		parent.sas.fscf.getCurrentDetailToolbar().setContentFor(nodeId);
		parent.frames[ "detail" ].location.href = ruleAction+'?method=showDeployment&type=Current';
	}else if((nodeId=="Active")) {
		var overviewFrame = parent.frames["overview"];
		parent.sas.fscf.getCurrentDetailToolbar().setContentFor(nodeId,"", "", "","", overviewFrame._canEnableDisable);
		parent.frames[ "detail" ].location.href = ruleAction+'?method=showDeployment&type=Active';
	}else if(nodeId=="build") {
		parent.sas.fscf.getCurrentDetailToolbar().setContentFor(nodeId, buildID);
		parent.frames[ "detail" ].location.href = ruleAction + "?method=listRules&showAll=true&workflow=" + nodeId + "&buildID=" + buildID;
	} else {
		var overviewFrame = parent.frames["overview"];
		parent.sas.fscf.getCurrentDetailToolbar().setContentFor(nodeId, overviewFrame._workingBuId,
				overviewFrame._mustRequestApprovalToPromote, overviewFrame._mustRequestApprovalToDeactivate, "", overviewFrame._canModify );
		parent.frames[ "detail" ].location.href = ruleAction + "?method=listRules&workflow=" + nodeId + "&showAll=" + (userId == "");
	}
}

function searchRules()
{
   var searchText = document.searchForm.searchText.value;
   searchText = searchText.replace(/^\s+/, '');
   searchText = searchText.replace(/\s+$/, '');
   if(searchText == '' || searchText == null)
   {
      return;
   }
   setCookie('rules_searchText',searchText);
   setBusyDetail();
   parent.sas.fscf.getCurrentDetailToolbar().setContentFor('searchResults');
   document.searchForm.submit();
}

function setSearchText(defaultValue)
{
   var searchText = getCookie('rules_searchText',defaultValue);
   document.searchForm.searchText.value = searchText;

}

function handleRowSelection(id, baseRuleId, name,ruleTypeName, description,operationalTimeLimit, version, lockVersion, isDeployed, state, guidedRule, transactionTypeId, multiOrgNodeId,queueId,
		alertTypeCode, alertReason, executionOrderPriority, row, className, event, prioritizeRules ) {
	//disable multi-select for priority screen
	if(prioritizeRules=='isPriority'){
		if(event.ctrlKey){
			return;
		}
	}
   // alert(event.shiftKey);

    var rule = new Object();
    rule.id = id;
    rule.baseRuleId = baseRuleId;
    rule.name = name;
    rule.description = description;
    rule.operationalTimeLimit=operationalTimeLimit;
    rule.version = version;
    rule.lockVersion = lockVersion;
    rule.state = state;
    rule.isDeployed = isDeployed;
    rule.guidedRule = guidedRule;
    rule.transactionTypeId = transactionTypeId;
    rule.multiOrgNodeId = multiOrgNodeId;
    rule.alertTypeCode=alertTypeCode;
    rule.queueId=queueId;
    rule.alertReason=alertReason;
    rule.executionOrderPriority=executionOrderPriority;
    rule.position = getPositionOfTableRow(row);
    highlightRow(row, className, event, rule);
}

// select all rows
function selectAllRows(tableId)
{
  // Simulate cntl key down
  var fakeEvent = new Object();
  fakeEvent.ctrlKey = 1;

  // for each row, run its onclick
  var table = document.getElementById(tableId);
  var rows = table.rows;
  var count = 0;
  for (var r=0; r<rows.length; r++)
  {
    if (rows[r].onclick)
    {
      // Make onclick code callable from here
      var func = rows[r].onclick.toString();
      func = func.substr(func.indexOf("{")+1);
      func = func.substr(0,func.length-1);
      func = func.replace("this","rows[r]");
      func = func.replace("event","fakeEvent");
      if (!window.XMLHttpRequest) eval(func);  // Avoid FF syntax error
    }
  }
}

function ibatisTesting()
{
   var link = action + "?method=ibatisTesting";
   setBusyDetail();
   parent.frames[ "detail" ].location.href = link;

}

// Returns legal sample percent from the of the tag or null if invalid
function getValidSamplePercent(tag) {
  var sampPct;
  try { sampPct = parseInt(tag.value); }
  catch (e) { }
  if (!sampPct || sampPct < 1 || sampPct > 100 || tag.value.indexOf('.')>=0)
  {
    sampPct = null;
    alert($i18n("rules.ruleAction.js.samplePercentInvalid2.alert.fmt.txt", [document.getElementById("samplePercent").value]));
  }
  return sampPct;
}

function openExportRulesWindow(link)
{

   var options = 'resizable=1,scrollbars=1,status=1,width=' + 200 + ',height=' + 150;
   alert(link);
   var exportWin = window.open(link, '','');
}


function copyRule()
{
   // TBD
}

function validateForm()
{
   var acct = document.getElementById("account").value;
   if (acct!=acct.replace(/[^a-zA-Z0-9\-=\.\+_%\$#@!&\*|:;<>,\?/]/,''))
   {
      alert($i18n("rules.ruleAction.js.accountCharsInvalid.alert.txt"));
      return false;
   }

   var sampPct = getValidSamplePercent(document.getElementById("samplePercent"));
   if (!sampPct)
       return false;

   if (!validateNotEmpty($i18n("rules.ruleAction.js.ruleType.txt"), document.ruleForm.ruleTypeId.value))
   {
        return false;
   }

   if (!validateNotEmpty($i18n("rules.ruleAction.js.ruleName.txt"), document.ruleForm.name.value))
   {
        document.ruleForm.name.select();
        document.ruleForm.name.focus();
        return false;
   }

   var multiOrgId = document.getElementById("multiOrgId");
   if (multiOrgId.selectedIndex==0)
   {
      alert($i18n("rules.ruleAction.js.multiOrgMissing.alert.txt"));
      return false;
   }

   var transactionTypeId = document.getElementById("transactionId").value;
   if (!validateNotEmpty($i18n("rules.ruleAction.js.ruleTransactionType.txt"), transactionTypeId))
   {
	   	document.ruleForm.transactionType.focus();
	   	return false;
   }

   var queueSelector = document.ruleForm.queueId;
   var selectedRuleType = getRuleType();
   var matchQueueType = selectedRuleType.match("Q") != null;
   var matchAuthType = selectedRuleType.match("A") != null;
   var queuedResponseMacros = new RegExp(document.ruleForm.queuedResponseMacros.value, 'i'); // S1046564
   var queuedResponseRule = document.ruleForm.code.value.match(queuedResponseMacros) != null; // S1046564
   if (matchQueueType || (matchAuthType && queuedResponseRule)) // if is queue rule or queued response auth rule
   {
      // queue must be selected (force XAMS queue if XAMS)
      if (document.getElementById('xamsSelection'))
          document.getElementById('xamsSelection').selected = 'selected';
      else if (queueSelector.options[queueSelector.selectedIndex].value == '')
      {
         alert($i18n("rules.ruleAction.js.queueMissing.alert.txt"));
         return false;
      }
      // alert type must be selected
      var alertType = document.ruleForm.alertType;
      if (alertType.value == '')
      {
         alert($i18n("rules.ruleAction.js.alertTypeMissing.alert.txt"));
         return false;
      }
      // selected components must contain the segment for this alertType key variable
      //var segAc= "GR" + alertType.value;
      var segAc = getSegmentForAlertType(alertType.value);
      var compSegIds = getComponentSegmentIds();
      // special handling for RUA segment
      if (segAc == 'RUA')
      {
      	 segAc = '_U_';
      }
      if (!hasSegment(compSegIds,segAc))
      {
         var compsForAlertType = new Object();
         for (var c in ComponentSegmentsMap)
         {
            if (hasSegment(ComponentSegmentsMap[c],segAc))
               compsForAlertType[c] = true;
         }
         var labs=getTransactionsForAlertType(compsForAlertType);//function defined in ruleDetailContents.jsp
         alert($i18n("rules.ruleAction.js.componentMissing.alert.fmt.txt", [alertType.options[alertType.selectedIndex].innerHTML, labs.join("\n")]));
         return false;
      }
   }

   var execOrderType = document.ruleForm.executionOrderType.value;
   if (execOrderType == '')
   {
      alert($i18n("rules.ruleAction.js.executionOrderMissing.alert.txt"));
      return false;
   }
   if (execOrderType!="0")
   {
     var executionOrderPriority = document.getElementById("executionOrderPriority").value.replace(/^\s*|\s*$/g,""); // Trim whitespace
     if (executionOrderPriority=='')
     {
         alert($i18n("rules.ruleAction.js.executionPriorityMissing.alert.txt"));
         return false;
     }
     if (!validateNumber(document.getElementById("executionOrderPriority"), $i18n("rules.ruleAction.js.ruleExecution.txt")))
     {
        return false;
     }
   }

   var descValue = document.ruleForm.description.value;
   if(descValue.length > 255)
   {
      alert($i18n("rules.ruleAction.js.ruleDescriptionLimit.alert.txt"));
      return false;
   }

   var alertReasonValue = document.ruleForm.alertReason.value;
   if(alertReasonValue.length > 255)
   {
      alert($i18n("rules.ruleAction.js.alertReasonLimit.alert.txt"));
      return false;
   }

   return true;
}

// Return true if the indicated segment acronym is in the supplied list of segment IDs
function hasSegment(segIds, segAc) {
   var s;
   for (s=0; s<segIds.length; s++)
   {
      var lab = SegmentLabelMap[segIds[s]];
      if (lab && lab.substr(0,3) == segAc)
        break;
   }
   return (s<segIds.length);
}

// Returns an array of segmentIds corresponding to the currently selected components
function getComponentSegmentIds() {
  var segSet = new Object();
  var compIdAry = getComponentIdArray();
  for (var i=0; i<compIdAry.length; i++) {
    var segs = ComponentSegmentsMap[compIdAry[i]];
    for (var s in segs) {
      segSet[segs[s]] = segs[s];
    }
  }
  var compSegs = new Array();

  var transactionTypeId = document.getElementById("transactionId").value;
  if (transactionTypeId != "")
  {
     var compIdAry2 = TransactionComponentsMap[transactionTypeId];
     for (var i=0; i<compIdAry2.length; i++)
     {
       var segs = ComponentSegmentsMap[compIdAry2[i]];
       for (var s in segs)
       {
         segSet[segs[s]] = segs[s];
       }
     }

     for (var s in segSet)
     {
       if (oseRuleSegmentIds[s]){
         compSegs.push(s);
         }
     }
  }
  else{
  	for (var s in segSet) {
    	var ruleType=getRuleType();
    	if (ruleType=="Q" && (!oseRuleSegmentIds[s]) ||
        ruleType!="Q" && oseRuleSegmentIds[s])
      	compSegs.push(s);
  	}
  }
  return compSegs;
}


// Notifies interested parties of a change in multiorg
function changeMultiOrg(tag) {
   // Nothing here right now
}

// Display a map nicely labeled for debug
function debugMap(lab,map) {
  var sb='';
  for (var key in map) sb += key+"="+map[key]+"\n";
  alert(lab+":\n"+sb);
}

var _ruleStateLabels = [];

function getRuleStateLabels()
{
	if ( _ruleStateLabels.length == 0 )
	{
		_ruleStateLabels["Coding"] = $i18n("rules.ruleAction.js.ruleState.Coding.txt");
		_ruleStateLabels["Testing"] = $i18n("rules.ruleAction.js.ruleState.Testing.txt");
		_ruleStateLabels["Production"] = $i18n("rules.ruleAction.js.ruleState.Production.txt");
		_ruleStateLabels["Deactivated"] = $i18n("rules.ruleAction.js.ruleState.Deactivated.txt");
		_ruleStateLabels["Trash"] = $i18n("rules.ruleAction.js.ruleState.Trash.txt");
		_ruleStateLabels["Archive"] = $i18n("rules.ruleAction.js.ruleState.Archive.txt");
	}
	return _ruleStateLabels;
}

// Returns true if the currently selected rule states do not match the indicated legal states
function hasUnacceptableStates(acceptableStatesList, msgKey) {
// debugger;
   var acStates = new Object();
   var acStatesAry = acceptableStatesList.split(" ");
   for (var s in acStatesAry) {
      acStates[acStatesAry[s]] = true;
   }
   var states = selectedRuleStates.split(",");
   for (var i=0; i<states.length; i++)
   {
      if (states[i] && !acStates[states[i]])
      {
    	 var ruleState = getRuleStateLabels()[states[i]];
    	 var ruleNumber = "" + selectedBaseRuleIds.split(",")[i] + "." + selectedRuleVersions.split(",")[i];

    	 alert($i18n(msgKey, [ruleState, ruleNumber]));

 //        alert(states[i] + " rule " + selectedBaseRuleIds.split(",")[i] + "." + selectedRuleVersions.split(",")[i] + " cannot " +
 //              msg + " because it is not in state: " + acceptableStatesList);
         return true;
      }
   }
   return false;
}



// Toggle for toolbars
var showFind = true;
var showEstimate = false;

function showFindToolbar(show)
{
   var findDiv = document.getElementById('findDiv');
   if(show)
      showFind = true;
   else   // toggle toolbar
      showFind = !showFind;

   if(showFind)
      findDiv.style.display = 'block'
   else
      findDiv.style.display = 'none';

   // showSeparator();

}


function showSeparator()
{
    // need a divider if search toolbar is also visible
   if(showFind && showEstimate)
      estimateSeparatorDiv.style.display = 'block';
   else
      estimateSeparatorDiv.style.display = 'none';
}



// Opens a new window with a printable form of the current rule
function showPrintableRule()
{
  var popH = 535;
  var popW = 735;
  theWindow = window.open("rules/printableRule.htm", "PrintableRule",
      'resizable=1,scrollbars=1,status=1,width=' + popW + ',height=' + popH);
  theWindow.focus();
}


// Returns the position of the indicated TR in its containing TABLE
function getPositionOfTableRow(row)
{
    var table = row.parentNode;
    while (table.tagName != "TABLE")
        table = table.parentNode;
    var rows = table.rows;
    var r;
    for (r=0; r<rows.length; r++)
        if (rows[r].id == row.id) break;
    return r;
}


// Return the update interval in milliseconds making it at least as large as the specified minimum
function getUpdateMilliseconds(minSec) {
  var upSec = document.getElementById("updateInterval").value;
  return (!upSec || upSec<minSec) ? minSec*1000 : upSec*1000;
}

// Opens a window containing a printable version of a table
function printOpenerTable(title,tableId)
{
  document.getElementById('printableVersionTitle').value = title;
  document.getElementById('printableVersionTableId').value = tableId;
  var w = window.open('rules/tiles/printOpenerTable.htm',
                      'Printable_'+tableId,
                      'menubar,toolbar,resizable=1, scrollbars=1, status=1, width=800, height=600');
  w.focus();
}

function getComponentIdArray() {
	var compIdsSet = new Array();
	// Get the components from checkboxes
	var inputTags = document.getElementsByTagName("INPUT");
	for (var t=0; t<inputTags.length; t++) {
	 var inputTag=inputTags[t];
	 if (inputTag.id && inputTag.id.substr(0,10)=="component_" && inputTag.checked) {
	   var assocIds = inputTag.value.split(":")[1].split(" ");
	   for (var a=0; a<assocIds.length; a++)
	     compIdsSet[assocIds[a]] = assocIds[a];
	 }
	}
	var compIdsArray = new Array();
	for (var c in compIdsSet)
	 compIdsArray.push(c);
	for (var s=0; s<SystemComponentIds.length; s++)
	 compIdsArray.push(SystemComponentIds[s]);
	compIdsArray.sort();
	return compIdsArray;
}
function getSpark(yValues){
	/********************************************/
	var width=30;
	var height=14;
	var padding;
	var fillColor="#c0d0f0";
	var lineColor="#0000f0";
	var dotColor="#f08000";
	//var yValues="float[]";
	var xLabels="string[]";
	/*********************************************/
	var spark="";
	if(yValues.length==1){//show flatline if a single value is present
		yValues[1]=yValues[0];
	}
	if(yValues!=undefined && yValues.length>1){
		var w=width;
		var h=height;
		var line_w = 2;
		var r = 2;
		var min = Math.min.apply(null, yValues);
		if (min < 0) {
			// normalize so all numbers are positive
			for (var i = 0; i < yValues.length; i++) {
				yValues[i] = yValues[i] + Math.abs(min);
			}
		}
		var max = Math.max.apply(null, yValues);
		min = Math.min.apply(null, yValues);
		var scale_y = (max == 0) ? 1 : h / max;
		var delta_x = w / Math.max(yValues.length - 1, 1);
		var base_x = r + 1;
		var base_h = h + base_x;
		var x = base_x;

		// add base_x * 2 to the width and height so that the dots don't get clipped
		spark+='<svg width="' + (w + (base_x * 2)) + '" height="' + (h + (base_x * 2)) + '"';
		if (padding != undefined) {
			spark+=' style="padding:' + padding + '"';
		}
		spark+='>';
		spark+='<g>';
		// polyfill
		spark+='<g stroke-width="1px" stroke="' + fillColor + '" fill="' + fillColor + '" vector-effect="non-scaling-stroke">';
		for (var i = 0; i < yValues.length - 1; i++) {
			if (i == 0) {
				spark+='<path d="M ' + x + ' ' + (base_h - (yValues[i] * scale_y)) + ' L ' + (x + delta_x) + ' ' + (base_h - (yValues[i + 1] * scale_y));
			} else {
				spark+=' L ' + (x + delta_x) + ' ' + (base_h - (yValues[i + 1] * scale_y));
			}
			if (i == yValues.length - 2) {
				spark+=' L ' + (x + delta_x) + ' ' + base_h + ' L ' + base_x + ' ' + base_h + ' Z" />';
			}
			x += delta_x;
		}
		spark+='</g>';
		// polyline
		spark+='<g stroke-width="' + line_w + 'px" stroke="' + lineColor + '" fill="none" vector-effect="non-scaling-stroke">';
		x = base_x;
		for (var i = 0; i < yValues.length - 1; i++) {
			if (i == 0) {
				spark+='<polyline points="' + x + ',' + (base_h - (yValues[i] * scale_y)) + ' ' + (x + delta_x) + ',' + (base_h - (yValues[i + 1] * scale_y));
			} else {
				spark+=' ' + (x + delta_x) + ',' + (base_h - (yValues[i + 1] * scale_y));
			}
			if (i == yValues.length - 2) {
				spark+='" />';
			}
			x += delta_x;
		}
		spark+='</g>';
		// dots
		spark+='<g stroke-width="1px" stroke="' + dotColor + '" fill="' + dotColor + '">';
		x = base_x;
		var bMinDrawn, bMaxDrawn = false;
		for (var i = 0; i < yValues.length; i++) {
			// only draw dots for the first, last, first min and first max values
			if (i == 0 || i == yValues.length - 1 || (yValues[i] == min && !bMinDrawn) || (yValues[i] == max && !bMaxDrawn)) {
				spark+='<circle cx="' + x + '" cy="' + (base_h - (yValues[i] * scale_y)) + '" r="' + r + '" />';
				if (yValues[i] == min) {
					bMinDrawn = true;
				}
				if (yValues[i] == max) {
					bMaxDrawn = true;
				}
			}
			x += delta_x;
		}
		spark+='</g>';
		spark+='</g>';
		spark+='</svg>';
	}
	return spark;
}

