const Prolog = (function(document) {
	const ToggleLabel = {
		SHOW : "Show prolog",
		HIDE : "Hide prolog",
	};

	const id = "prolog";
	const toggles = [];
	const togglesIds = [ id + "Toggle1", id + "Toggle2" ];
	let divElt = null;

	const getElt = function() {
		if (divElt === null) {
			divElt = document.getElementById(id);
		}
		return divElt;
	};

	const getToggles = function() {
		if (toggles.length === 0) {
			togglesIds.forEach(function(toggleId) {
				const toggle = document.getElementById(toggleId);
				if (toggle !== null) {
					toggles.push(toggle);
				}
			} );
		}
		return toggles;
	};

	const isShown = function() {
		return getElt().style.display !== "none";
	};

	const toggleDisplay = function() {
		const isPrologShown = isShown();
		const newLabel = isPrologShown ? ToggleLabel.SHOW : ToggleLabel.HIDE;

		toggleEltDisplay(getElt());
		const myToggles = getToggles();
		myToggles.forEach(function(toggle) {
			toggle.text = newLabel;
		} );
		myToggles[1].style.display = isPrologShown ? "none" : "block";
	};

	const expand = function() {
		if (!isShown()) {
			toggleDisplay();
		}
	};

	return {
		expand : expand,
		id: id,
		toggleDisplay : toggleDisplay,
	};
} )(document);

const Epilog = (function(document) {
	const ToggleLabel = {
		SHOW : "Show epilog",
		HIDE : "Hide epilog",
	};

	const id = "epilog";
	const toggles = [];
	const togglesIds = [ id + "Toggle1", id + "Toggle2" ];
	let divElt = null;

	const getElt = function() {
		if (divElt === null) {
			divElt = document.getElementById(id);
		}
		return divElt;
	};

	const getToggles = function() {
		if (toggles.length === 0) {
			togglesIds.forEach(function(toggleId) {
				const toggle = document.getElementById(toggleId);
				if (toggle !== null) {
					toggles.push(toggle);
				}
			} );
		}
		return toggles;
	};

	const isShown = function() {
		return getElt().style.display !== "none";
	};

	const toggleDisplay = function() {
		const isEpilogShown = isShown();
		const newLabel = isEpilogShown ? ToggleLabel.SHOW : ToggleLabel.HIDE;

		toggleEltDisplay(getElt());
		const myToggles = getToggles();
		myToggles.forEach(function(toggle) {
			toggle.text = newLabel;
		} );
		myToggles[1].style.display = isEpilogShown ? "none" : "block";
	};

	const expand = function() {
		if (!isShown()) {
			toggleDisplay();
		}
	};

	return {
		expand : expand,
		id: id,
		toggleDisplay : toggleDisplay,
	};
} )(document);

function toggleEltDisplay(elt) {
	elt.style.display = (elt.style.display === "none") ? "block" : "none";
}

function handleNextMessageClick(event) {
	const $a = $(event.currentTarget);
	const context = $a.data("nextAnchorContext");
	switch (context) {
		case Prolog.id:
			Prolog.expand();
			break;
		case Epilog.id:
			Epilog.expand();
			break;
		default:
	}
}

function attachClickHandlerToMsgLinkes() {
	$("a[id^='warnerr']").each(function () {
		$(this)
			.css("text-decoration", "none")
			.click(handleNextMessageClick);
	} );
	$("a[id*='Toggle']").each(function () { // override sasStyle.css (for log of an estimation)
		$(this).css({"text-decoration":"underline", color:"blue"});
	} );
}

$().ready(function () {
	attachClickHandlerToMsgLinkes();
} );
