<%/*--------------------------------------------------------------------------------------|
|Copyright (c) 2005-2009, SAS Institute, Inc.  All Rights Reserved.
|
|NAME: rules/tiles/ruleEstimatesRulesLegend.jsp
|DESC: JSP page to display rules used in estimation
|---------------------------------------------------------------------------------------*/%>

<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>


<c:choose>
<c:when test="${fn:indexOf(displayList,'selectedRules')<0}">
  <span id='selectedRules_opener' title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleEstimatesRulesLegend.clickToView.title.txt'/></esapi:encodeForHTMLAttribute>" onclick="_showEstimateReport('${estimateId}', '', 'selectedRules');" style="cursor:pointer;font-weight:bold;">
    <fmt:message key="rules.ruleEstimatesRulesLegend.reportTitle.rulesDetails.txt"/><image src="images/rules/opener.gif" />
  </span>
</c:when>

<c:when test="${selectedRulesSize>0}">
  <span id='selectedRules_opener' title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleEstimatesRulesLegend.clickToView.title.txt'/></esapi:encodeForHTMLAttribute>" onclick="revealEstimateReport('selectedRules');" style="cursor:pointer;font-weight:bold;display:none;">
    ${title} <image src="images/rules/opener.gif" />
  </span>

  <span id='selectedRules_closer' style="width:100%;text-align:left;">
    <span title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleEstimatesRulesLegend.clickToHide.title.txt'/></esapi:encodeForHTMLAttribute>" onclick="hideEstimateReport('selectedRules');" style="cursor:pointer;font-weight:bold;">
      ${title}&nbsp;&nbsp;<image src="images/rules/closer.gif" />
    </span>
    <image src="images/rules/printer.gif" title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleEstimatesRulesLegend.viewPrintableVersion.title.txt'/></esapi:encodeForHTMLAttribute>" onclick="printOpenerTable('${esapi:encodeForJavaScript(title)}','selectedRules_table')" />
    <%-- image src="images/rules/icon-excel.gif"
           title="Export to Excel"
           onclick="top.frames['detail'].location.href = estimateAction + '?method=viewEstimateReportAsXls&fileName=selected_rules.xls&estimateId=${estimateId}'"
           style="cursor:pointer" / --%>
    <br><br>
    <ec:table
       items="selectedRules"
       var="selectedRule"
       action="r_ruleEstimates.do"
       title="${title}"
       width="100%"
       sortable="false"
       filterable="false"
       showExports="true"
       showStatusBar="false"
       showPagination="false"
       tableId="selectedRules"
       styleClass="mainTable"
       rowsDisplayed="${selectedRulesSize}"
       view="html2"
     >
     <ec:row>
        <ec:column property="RULE_ID" title="<fmt:message key='rules.ruleEstimatesRulesLegend.ruleId.title.txt'/>" headerClass="centeredTableHeader" headerStyle="border-top:1px solid #7F9DB9;color:#353535;font-weight:bold;" styleClass="textTableCellNoWrap">
          ${selectedRule.baseRuleId}.${selectedRule.version}
        </ec:column>
        <ec:column property="RULE_TYPE" title="<fmt:message key='rules.ruleEstimatesRulesLegend.ruleType.title.txt'/>" headerClass="centeredTableHeader" headerStyle="border-top:1px solid #7F9DB9;color:#353535;font-weight:bold;" styleClass="textTableCellNoWrap">
          <fmt:message key="rules.ruleType.${selectedRule.ruleTypeName}.txt"/>${selectedRule.alertTypeCodeLabel}
        </ec:column>
        <ec:column property="RULE_NAME" title="<fmt:message key='rules.ruleEstimatesRulesLegend.ruleName.title.txt'/>" headerClass="centeredTableHeader" headerStyle="border-top:1px solid #7F9DB9;color:#353535;font-weight:bold;" styleClass="textTableCell">
          ${esapi:encodeForHTML(selectedRule.name)} 
        </ec:column>
        <ec:column property="RULE_STATE" title="<fmt:message key='rules.ruleEstimatesRulesLegend.ruleState.title.txt'/>" headerClass="centeredTableHeader" headerStyle="border-top:1px solid #7F9DB9;color:#353535;font-weight:bold;" styleClass="textTableCellNoWrap">
          <fmt:message key='rules.ruleState.${selectedRule.workflowState}.txt'/>
        </ec:column>
        <ec:column property="RULE_DESC" title="<fmt:message key='rules.ruleEstimatesRulesLegend.ruleDescription.title.txt'/>" headerClass="centeredTableHeader" headerStyle="border-top:1px solid #7F9DB9;color:#353535;font-weight:bold;" styleClass="textTableCell">
          ${esapi:encodeForHTML(selectedRule.description)}
        </ec:column>
        <ec:column property="RULE_CODE" title="<fmt:message key='rules.ruleEstimatesRulesLegend.ruleCode.title.txt'/>" headerClass="centeredTableHeader" headerStyle="border-top:1px solid #7F9DB9;color:#353535;font-weight:bold;" styleClass="textTableCell">
          <pre style="margin-bottom:0px;">${esapi:encodeForHTML(selectedRule.code)}</pre> 
        </ec:column>
        <ec:column property="COMPONENTS" title="<fmt:message key='rules.ruleEstimatesRulesLegend.component.title.txt'/>" headerClass="centeredTableHeader" headerStyle="border-top:1px solid #7F9DB9;color:#353535;font-weight:bold;" styleClass="textTableCell">
          <table>
          <c:if test="${not empty selectedRule.accountValues}"> <tr id="subTab0r"><td id="subTab0a" style="text-align:left;width:1%;"><fmt:message key="rules.ruleEstimatesRulesLegend.component.account.txt"/>: </td>    <td id="subTab0b" style="vertical-align:top;">${selectedRule.accountValues}.</td></tr></c:if>
          <c:if test="${not empty selectedRule.activityValues}"><tr id="subTab0r"><td id="subTab1b" style="text-align:left;width:1%;"><fmt:message key="rules.ruleEstimatesRulesLegend.component.activity.txt"/>: </td>   <td id="subTab1b" style="vertical-align:top;">${selectedRule.activityValues}.</td></tr></c:if>
          <c:if test="${not empty selectedRule.channelValues}"> <tr id="subTab0r"><td id="subTab2c" style="text-align:left;width:1%;"><fmt:message key='rules.ruleEstimatesRulesLegend.component.channel.txt'/>: </td>    <td id="subTab2b" style="vertical-align:top;">${selectedRule.channelValues}.</td></tr></c:if>
          <c:if test="${not empty selectedRule.customerValues}"><tr id="subTab0r"><td id="subTab3d" style="text-align:left;width:1%;"><fmt:message key='rules.ruleEstimatesRulesLegend.component.customer.txt'/>: </td>   <td id="subTab3b" style="vertical-align:top;">${selectedRule.customerValues}.</td></tr></c:if>
          <c:if test="${not empty selectedRule.authenticationValues}"><tr id="subTab0r"><td id="subTab4e" style="text-align:left;width:1%;"><fmt:message key='rules.ruleEstimatesRulesLegend.component.authentication.txt'/>: </td> <td id="subTab4b" style="vertical-align:top;">${selectedRule.authenticationValues}.</td></tr></c:if>
          </table>
        </ec:column>
        <ec:column property="RULE_LSTUPDT" title="<fmt:message key='rules.ruleEstimatesRulesLegend.lastUpdated.title.txt'/>" headerClass="centeredTableHeader" headerStyle="border-top:1px solid #7F9DB9;color:#353535;font-weight:bold;" styleClass="textTableCell">
		  <span sortValue="${selectedRule.lastUpdateUtcMillies}"><fmt:formatDate value='${selectedRule.lastUpdateTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/></span>
          <fmt:message key="rules.ruleEstimatesRulesLegend.byUser.fmt.txt"><fmt:param>${esapi:encodeForHTML(selectedRule.lastUpdateUser)}</fmt:param></fmt:message>
        </ec:column>
     </ec:row>
    </ec:table>
  </span>
</c:when>

<c:otherwise>
  <span id='selectedRules_opener' title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleEstimatesRulesLegend.clickToReshow.title.txt'/></esapi:encodeForHTMLAttribute>" onclick="_showEstimateReport('${estimateId}', '', 'selectedRules');" style="cursor:pointer;font-weight:bold;">
    ${title} <image src="images/rules/opener.gif" />
  </span>
</c:otherwise>

</c:choose>

