<%/*--------------------------------------------------------------------------------------|
|Copyright (c) 2005-2008, SAS Institute, Inc.  All Rights Reserved.
|
|NAME: rules/tiles/ruleProperties.jsp
|DESCRIPTION: JSP page to allow the setting and display of rule general properties
|---------------------------------------------------------------------------------------*/%>


<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<STYLE>
.softNone
{
   color:black;
   font-style:italic;
   font-family:'AvenirNext',sans-serif;
   font-size:0.88rem;
}
</STYLE>
<TABLE  border="0" name="rulePropertiesTable" style="border:0px;margin-left:0px; margin-right:10px" class="ruleIdeTable"
   cellspacing="0" cellpadding="0" width="100%">


   <%-- Establish column width and alignment on page --%>
   <tr class="ruleIdeTableDataRow" border=1>
        <td style="width:1%;" class="ruleIdeTableLabel"> &nbsp;</td>
        <td style="width:1%;"> &nbsp;</td>
        <td style="width:1%;"> &nbsp;</td>
        <td style="width:40%"> &nbsp;</td>
        <td style="width:1%;" class="ruleIdeTableLabel"> &nbsp;</td>
        <td style="width:10%"> &nbsp;</td>
        <td style="width:30%"> &nbsp;</td>
        <td style="width:1%;"> &nbsp;</td>
        <td style="width:1%;"> &nbsp;</td>
   <tr>


   <%-- Set time format (pending notice from Sriram on using a property for this) --%>
   <c:set var="pageTimeFormat" value="${timeFormat}"/>
   <c:if test="${empty pageTimeFormat}">
      <c:set var="pageTimeFormat" value="${timeFormat}"/>
   </c:if>

   <c:set var="baseRuleIdDisplayString">(<fmt:message key="rules.rule.statusNew.txt" />) </c:set>
   <c:set var="createdDisplayString">(<fmt:message key="rules.rule.statusNew.txt" />) </c:set>
   <c:set var="updatedDisplayString">(<fmt:message key="rules.rule.statusNew.txt" />) </c:set>
   <c:set var="checkoutDisplayString">(<fmt:message key='rules.rule.statusNew.txt' />) </c:set>
   <c:if test="${rule != null}">
     <c:set var="baseRuleIdDisplayString">
       ${rule.baseRuleId}.${rule.version} (<fmt:message key="rules.rule.ruleState.${rule.workflow.state}.txt"/>)
     </c:set>
     <c:set var="createdDisplayString">
        <fmt:formatDate value='${rule.createTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
        &nbsp;
        <fmt:message key="rules.rule.byUser.fmt.txt">
        	<fmt:param>${fn:escapeXml(rule.createUser)}</fmt:param>
        </fmt:message>
     </c:set>
     <c:set var="updatedDisplayString">
        <fmt:formatDate value='${rule.lastUpdateTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
        &nbsp;
        <fmt:message key="rules.rule.byUser.fmt.txt">
            <fmt:param>${fn:escapeXml(rule.lastUpdateUser)}</fmt:param>
        </fmt:message>
     </c:set>
     <c:set var="checkoutDisplayString">
        <fmt:formatDate value='${rule.checkoutTime}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
        &nbsp;
        <fmt:message key="rules.rule.byUser.fmt.txt">
           <fmt:param>${fn:escapeXml(rule.checkoutUser)}</fmt:param>
        </fmt:message>
     </c:set>
   </c:if>


   <tr class="ruleIdeTableDataRow">
     <td valign="top" class="ruleIdeTableLabel"><fmt:message key="rules.rule.id.txt"/>:&nbsp;</td>
     <td valign="top" class="ruleIdeTableValue" colspan='3'>
       <%-- Rule type is a selector only for new rules --%>
       <input type="hidden" name="isTenantInstall" id="isTenantInstall" value="${isTenantInstall}" />
       <c:choose>
        <c:when test="${rule != null}">
          <input type="hidden" name="ruleTypeId" id="ruleTypeId" value="${rule.ruleType.id}"/>
          <c:choose>
            <c:when test="${isTenantInstall == true}">
               <span id="baseRuleIdInfo">${baseRuleIdDisplayString}</span>
               <span id="ruleTypeInfo" style="position:relative;left:-4000px"><fmt:message key="rules.ruleType.${rule.ruleType.name}.txt"/></span>
            </c:when>
            <c:otherwise>
               <span id="ruleTypeInfo"><fmt:message key="rules.ruleType.${rule.ruleType.name}.txt"/></span>
               <span id="baseRuleIdInfo">${baseRuleIdDisplayString}</span>
            </c:otherwise>
          </c:choose>
        </c:when>
        <c:otherwise>
          <c:set var="tenantRuleTypeId"/>
          <span id="ruleTypeInfo">
            <c:choose>
              <c:when test ="${isTenantInstall == true}">
                (<fmt:message key="rules.rule.statusNew.txt" />)
                <c:forEach var="opt" items="${sasEditorSelectorMaps.ruleTypeLabelMap}">
                  <c:if test='${opt.value=="Authorization"}'>
                     <input type="hidden" name="ruleTypeId" id="ruleTypeId" value="${opt.key}"/>
                  </c:if>
                </c:forEach>
              </c:when>
              <c:otherwise>
                <select name="ruleTypeIdSelector" id="ruleTypeIdSelector" style="width:100%;font-size:100%;" onchange="changeRuleTypeSelector();resizeProperties();enableSaveButton(event);">
                  <c:forEach var="opt" items="${sasEditorSelectorMaps.ruleTypeLabelMap}">
                    <c:choose>
                      <c:when test='${opt.value=="Authorization"}'>
                        <option value="${opt.key}" selected><fmt:message key="rules.ruleType.${fn:escapeXml(opt.value)}.txt"/></option>
                      </c:when>
                      <c:otherwise>
                        <option value="${opt.key}"><fmt:message key="rules.ruleType.${fn:escapeXml(opt.value)}.txt"/></option>
                      </c:otherwise>
                    </c:choose>
                  </c:forEach>
                </select>
                <input type="hidden" name="ruleTypeId" id="ruleTypeId"/>
            	<script>document.ruleForm.ruleTypeId.value = document.ruleForm.ruleTypeIdSelector.value;</script>
              </c:otherwise>
            </c:choose>
          </span>
          <span id="baseRuleIdInfo"></span>
       </c:otherwise>
       </c:choose>
     </td>
      <td valign="top" colspan='2' nowrap class="ruleIdeTableLabel"><fmt:message key="rules.rule.created.txt"/>:</td>
      <td valign="top" id='createdInfo' colspan="2" class="ruleIdeTableValue">${createdDisplayString}</td>
      <td>&nbsp;</td>
   </tr>


   <tr class="ruleIdeTableDataRow">
      <td valign="top" nowrap class="ruleIdeTableLabel" ><fmt:message key="rules.rule.businessUnit.txt"/>:&nbsp;</td>
      <td valign="top" id='ruleBusinessUnitInfo' colspan='3' class="ruleIdeTableValue">${esapi:encodeForHTML(ruleBusinessUnit.buName)}&nbsp; (${esapi:encodeForHTML(fn:trim(ruleBusinessUnit.rootMultiOrgNodeKey))})</td>
     <td colspan='2' valign="top" nowrap class="ruleIdeTableLabel"><fmt:message key="rules.rule.updated.txt"/>:</td>
     <td id='updatedInfo' valign="top" colspan="2" class="ruleIdeTableValue">${updatedDisplayString}</td>
     <td>&nbsp;</td>
   </tr>

   <tr class="ruleIdeTableDataRow"><td colspan="9" valign="top" style="height:5px;" class="ruleIdeTableLabel"></td></tr>

   <tr class="ruleIdeTableDataRow">
     <td valign="top" class="ruleIdeTableLabel"><fmt:message key="rules.rule.name.txt" />:&nbsp;</td>
     <td valign="top" colspan='3' style="padding:0px 0px 0px 0px;">
        <input name="name" id="name" type="text" class="generic" value="${fn:escapeXml(rule.name)}" style="width:100%" maxlength="50" onkeypress='checkCharacters(event);' onkeydown='checkCharacters(event);' onchange='enableSaveButton(event);' />
     </td>

     <td colspan='2' valign="top" align="left" nowrap class="ruleIdeTableLabel"><fmt:message key="rules.rule.executionOrder.txt" />:</td>
     <td id="xeqTypeTD" colspan="1" valign="top" align="left" nowrap style="width:100%;padding:0px 0px 0px 0px;">
       <select  style="width:100%; margin-left:0px; margin-right:0px;font-size:100%;"
                align="left"
                name="executionOrderType" id="executionOrderType" onchange="enableSaveButton(event);changeExecutionPrioritySelector();">


          <c:set var="selected" value=""/>

          <c:forEach var="opt" items="${orderTypes}">
            <c:if test="${opt.key == rule.executionOrderType}">
              <c:set var="selected" value="${opt.key}"/>
            </c:if>
          </c:forEach>

          <c:if test="${empty selected }" >
            <c:set var="selected" value="0"/>
          </c:if>

          <c:forEach var="opt" items="${orderTypes}">
            <c:choose>
            <c:when test="${opt.key == selected}">
              <option value="${opt.key}" selected='selected'><fmt:message key="rules.ruleExecutionOrderType.${fn:escapeXml(opt.value)}.txt"/>&nbsp;&nbsp;</option>
             </c:when>
            <c:otherwise>
              <option value="${opt.key}"><fmt:message key="rules.ruleExecutionOrderType.${fn:escapeXml(opt.value)}.txt"/>&nbsp;&nbsp;</option>
            </c:otherwise>
            </c:choose>
          </c:forEach>

       </select>
     </td>
     <td id="xeqPrtyTD" valign="top" align="right" nowrap style="display:;padding:0px 0px 0px 0px;">
       <input name="prty" id="prty" type="hidden" value='<fmt:message key="rules.rule.executionOrder.priority.txt"/>'/>
       <c:if test='${empty rule.executionOrderPriority}'><input name="executionOrderPriority" id="executionOrderPriority" type="hidden" value="0"/></c:if>
       <c:if test='${not empty rule.executionOrderPriority}'><input name="executionOrderPriority" id="executionOrderPriority" type="hidden" value="${rule.executionOrderPriority}"/><div name="executionOrderPriority" id="executionOrderPriorityDiv">&nbsp;(${rule.executionOrderPriority})</div></c:if>
     </td>
     <td>&nbsp;</td>
   </tr>

   <tr class="ruleIdeTableDataRow"><td colspan="9" valign="top" style="height:20px;" class="ruleIdeTableLabel"></td></tr>


   <c:set var="visibility" value="visible"/>                                       <%-- S0750302 --%>
   <c:if test="${!empty enableXAMS}">                                              <%-- S0750302 --%>
      <c:set var="visibility" value="hidden"/>                                     <%-- S0750302 --%>
   </c:if>                                                                         <%-- S0750302 --%>
   <tr class="ruleIdeTableDataRow" id="queueRow" style="visibility:${visibility}"> <%-- S0750302 --%>
      <td valign="top" id="queueLabel" style="display:" class="ruleIdeTableLabel"><fmt:message key="rules.rule.queue.txt" />:&nbsp;</td>
      <td valign="top" id="queueValue"  style="padding:0px 0px 0px 0px;display:" colspan="7">
        <select name="queueId" id="queueId" style="width:100%" onchange="enableSaveButton(event);">
          <c:set var="selected" value=""/>
          <c:set var="selectionExists" value="" />
          <c:set var="xamsSelection" value="" />
          <option value=""><fmt:message key="rules.rule.select.queue.txt"/>&nbsp;&nbsp;</option>
          <c:forEach var="opt" items="${queues}">
            <c:choose>
            <c:when test="${opt.id == -2 && !empty enableXAMS}"> <%-- S0750302 --%>
              <c:set var="selected" value="selected='selected'"/>
              <c:set var="selectionExists" value="selected='selected'"/>
              <c:set var="xamsSelection" value="id='xamsSelection'"/>
            </c:when>
            <c:when test="${!empty rule.queueId && opt.id == rule.queueId}"> <%-- S0750302 --%>
              <c:set var="selected" value="selected='selected'"/>
              <c:set var="selectionExists" value="selected='selected'"/>
            </c:when>
            <c:otherwise>
               <c:set var="selected" value=""/>
            </c:otherwise>
            </c:choose>
            <option ${xamsSelection} value="${opt.id}" ${selected}>${fn:escapeXml(opt.name)} (<fmt:message key="rules.rule.queue.status.${opt.status}.txt"/>-${opt.priority})</option>
          </c:forEach>
        </select>
      </td>
      <td>&nbsp;</td>
   </tr>


   <tr class="ruleIdeTableDataRow" id="alertTypeRow">
      <td valign="top" id="alertTypeLabel" style="display:" class="ruleIdeTableLabel"><fmt:message key="rules.rule.alert.type.txt"/>:&nbsp;</td>
      <td valign="top" id="alertTypeValue" style="display:;padding:0px 0px 0px 0px;" colspan="7">
        <select name="alertType" id="alertType" style="width:100%" onchange="enableSaveButton(event);loadMacroExpansions();">
          <option value=""><fmt:message key="rules.rule.select.alert.type.txt"/>&nbsp;&nbsp;</option>
          <c:forEach var="alrt" items="${alertTypes}">
            <option value="${alrt.key}" <c:if test='${rule.alertTypeCode==alrt.key}'>selected</c:if>> ${alrt.value.desc} (${alrt.key}) </option>
          </c:forEach>
        </select>
        <input type="hidden" id="highlightAlertType" value="${highlightAlertType}"/>
      </td>
      <td>&nbsp;</td>
   </tr>


   <tr class="ruleIdeTableDataRow"><td colspan="9" valign="top" style="height:10px;display:none;" class="ruleIdeTableLabel"></td></tr>

   <tr class="ruleIdeTableDataRow" style="display:">
      <td valign="top" nowrap class="ruleIdeTableLabel"><fmt:message key="rules.rule.transactionScope.txt" />:&nbsp;</td>
      <td valign="top" colspan='7' style="padding:0px 0px 0px 0px;">
        <select name="multiOrgId" id="multiOrgId" style="width:100%" onchange='enableSaveButton(event);changeMultiOrg();'>
          <c:set var="selected" value=""/>
          <c:set var="selectionExists" value="" />
          <c:choose>
             <c:when test="${empty selectionExists }" >
                <option selected value=""><fmt:message key="rules.rule.select.multiorg.txt"/>&nbsp;&nbsp;</option>
             </c:when>
             <c:otherwise>
                <option value=""><fmt:message key="rules.rule.select.multiorg.txt"/>&nbsp;&nbsp;</option>
             </c:otherwise>
          </c:choose>
          <c:forEach var="opt" items="${multiOrgNodes}">
            <c:choose>
            <c:when test="${opt.id == rule.multiOrgNode.id}">
              <c:set var="selected" value="selected='selected'"/>
              <c:set var="selectionExists" value="selected='selected'"/>
            </c:when>
            <c:otherwise>
              <c:set var="selected" value=""/>
            </c:otherwise>
            </c:choose>
            <c:set var="morgIndent" value="${fn:substring('_______',1,fn:length(fn:trim(opt.key)))}"/>
            <option value="${opt.id}" ${selected}> ${morgIndent}${fn:trim(fn:escapeXml(opt.label))}&nbsp; (${fn:trim(fn:escapeXml(opt.key))})</option>
          </c:forEach>
        </select>
      </td>
     <td>&nbsp;</td>
   </tr>

   <tr class="ruleIdeTableDataRow"><td colspan="9" valign="top" style="height:10px;" class="ruleIdeTableLabel"></td></tr>


   <tr class="ruleIdeTableDataRow" >
      <td valign="top" class="ruleIdeTableLabel"><fmt:message key="rules.rule.transactionType.txt"/>:&nbsp;</td>
      <td colspan="7" valign="top" style="padding:0px 0px 0px 0px;">
        <select id="transactionId" name="transactionId" style="width:100%" onchange="enableSaveButton(event);loadMacroExpansions();loadOverviewExpansions();">
          <option value="" style="color:black;"><fmt:message key="rules.rule.select.components.txt"/></option>
          <c:forEach var="t" items="${sasEditorSelectorMaps.tranLabelMap}">
            <option value="${t.key}" style="color:black;" <c:if test="${t.key==rule.transactionType.id}">selected</c:if>>${t.value}</option>
          </c:forEach>
        </select>
      </td>
      <td valign='top'><image src="images/rules/Search.gif" border="0" onclick="showScavenger('transactionId',${fn:length(sasEditorSelectorMaps.tranLabelMap)})" title="<fmt:message key="rules.rule.filter.keywords.txt"/>" style="cursor:pointer;" /></td>
   </tr>
   <tr class="ruleIdeTableDataRow"><td colspan="9" valign="top" style="height:20px;" class="ruleIdeTableLabel"></td></tr>


   <tr class="ruleIdeTableDataRow" >
      <td valign="top" class="ruleIdeTableLabel"><fmt:message key="rules.rule.desc.txt" />:&nbsp;</td>
      <td colspan="7" valign="top" style="padding:0px 0px 0px 0px;">
        <textarea name="description" id="description" style="height:50px;width:99%;" wrap="PHYSICAL" onkeyup='enableSaveButton(event);' onchange='enableSaveButton(event);'>${fn:escapeXml(rule.description)}</textarea>
      </td>
      <td valign="top">
        <%-- Controls for shrinking/enlarging box --%>
        <span title="<fmt:message key="rules.rule.shrink.selector.txt"/>" style="cursor:pointer" onclick="if (parseInt(document.getElementById('description').style.height) > 100) document.getElementById('description').style.height = parseInt(document.getElementById('description').style.height)-100"><image src="images/rules/closer.gif" border="0"/></span><br>
        <image src="images/rules/blank.gif" border="0" height="2" width='1'/><br>
        <span title="<esapi:encodeForHTMLAttribute><fmt:message key="rules.rule.expand.selector.txt"/></esapi:encodeForHTMLAttribute>" style="cursor:pointer" onclick="document.getElementById('description').style.height=100+parseInt(document.getElementById('description').style.height)";><image src="images/rules/opener.gif" border="0"/></span><br>
      </td>
   </tr>
   
   <tr class="ruleIdeTableDataRow" >
      <td valign="top" class="ruleIdeTableLabel"><fmt:message key="rules.rule.operationalTimeLimit.txt" />:&nbsp;</td>
      <td colspan="7" valign="top" style="padding:0px 0px 0px 0px;">
        <input type="text" name="otl" id="otl" value="${fn:escapeXml(rule.operationalTimeLimit)}" style="width:99%;" wrap="PHYSICAL" onkeyup='enableSaveButton(event);' onchange='enableSaveButton(event);'>
      	<input type="hidden" name="operationalTimeLimit" id="operationalTimeLimit" value="${fn:escapeXml(rule.operationalTimeLimit)}"/>
      </td>
      <td valign="top">
        <%-- Controls for shrinking/enlarging box --%>
        <span title="<fmt:message key="rules.rule.shrink.selector.txt"/>" style="cursor:pointer" onclick="if (parseInt(document.getElementById('description').style.height) > 100) document.getElementById('description').style.height = parseInt(document.getElementById('description').style.height)-100"><image src="images/rules/closer.gif" border="0"/></span><br>
        <image src="images/rules/blank.gif" border="0" height="2" width='1'/><br>
        <span title="<esapi:encodeForHTMLAttribute><fmt:message key="rules.rule.expand.selector.txt"/></esapi:encodeForHTMLAttribute>" style="cursor:pointer" onclick="document.getElementById('description').style.height=100+parseInt(document.getElementById('description').style.height)";><image src="images/rules/opener.gif" border="0"/></span><br>
      </td>
   </tr>
   <script type="text/javascript">  
	   $(function(){  
		$("#otl").bind('keypress',function(e){  
			  if(e.keyCode == '9' || e.keyCode == '16'){  
				return;  
			   }  
			   var code;  
			   if (e.keyCode) code = e.keyCode;  
			   else if (e.which) code = e.which;   
			   if(e.which == 46)  
				return false;  
			   if (code == 8 || code == 46)  
				return true;  
			   if (code < 48 || code > 57)  
				return false;  
		     }  
		);  
		$("#operationalTimeLimit").bind("paste",function(e) {  
		     e.preventDefault();  
		});  
		$("#operationalTimeLimit").bind('mouseenter',function(e){  
		      var val = $(this).val();  
		      if (val!='0'){  
			   val=val.replace(/[^0-9]+/g, "")  
			   $(this).val(val);  
		      }  
		});  
	   });  
   </script>  
   


  <tr id="alertReasonRow" name="alertReasonRow" class="ruleIdeTableDataRow" z-index="-1" >
     <td valign="top" class="ruleIdeTableLabel"><fmt:message key="rules.rule.alert.reason.txt"/>:&nbsp;</td>
     <td colspan="7" valign="top" style="padding:0px 0px 0px 0px;">
       <textarea name="alertReason" id="alertReason" style="height:50px;width:99%;" wrap="PHYSICAL" onkeyup='enableSaveButton(event);' onchange='enableSaveButton(event);'>${fn:escapeXml(rule.alertReason)}</textarea>
     </td>
     <td valign="top">
       <%-- Controls for shrinking/enlarging box --%>
       <span title="<fmt:message key="rules.rule.shrink.selector.txt"/>" style="cursor:pointer" onclick="if (parseInt(document.getElementById('alertReason').style.height) > 100) document.getElementById('alertReason').style.height = parseInt(document.getElementById('alertReason').style.height)-100"><image src="images/rules/closer.gif" border="0"/></span><br>
       <image src="images/rules/blank.gif" border="0" height="2" width='1'/><br>
       <span title="<esapi:encodeForHTMLAttribute><fmt:message key="rules.rule.expand.selector.txt"/></esapi:encodeForHTMLAttribute>" style="cursor:pointer" onclick="document.getElementById('alertReason').style.height=100+parseInt(document.getElementById('alertReason').style.height)";><image src="images/rules/opener.gif" border="0"/></span><br>
      </td>
   </tr>

   <tr class="ruleIdeTableDataRow"><td colspan="9" valign="top" style="height:5px;" class="ruleIdeTableLabel"></td></tr>
   <tr class="ruleIdeTableDataRow"><td colspan="9" valign="top" class="ruleIdeTableLabel" style="height:5px;"></td></tr>

   <%-- Value of preRequisites is set when rule code is parsed --%>
   <input type="hidden" name="preRequisites"   id="preRequisites"   value="" />
   <input type="hidden" name="preRequisiteIds" id="preRequisiteIds" value="<c:forEach var='d' items='${rule.ruleDependencies}'>#${d.baseRuleId} </c:forEach>" />
   <tr class="ruleIdeTableDataRow">
     <td valign="top" style="padding-top:0;" class="ruleIdeTableLabel"><fmt:message key="rules.rule.dependencies.txt"/>:&nbsp;</td>
     <td valign="top" colspan="7" style="padding:0px 0px 0px 0px;text-align:left;">
        <span id="preRequisitesForDisplay"></span>
        <span id="dependencySeparator">
          <c:choose>
            <c:when test="${not empty rule && not empty rule.ruleDependencies && not empty rule.weakDependencies}"><br></c:when>
            <c:when test="${    empty rule || (   empty rule.ruleDependencies &&     empty rule.weakDependencies)}"><span class="softNone"><fmt:message key="rules.rule.dependency.none.txt" /></span></c:when>
            <c:otherwise> </c:otherwise>
          </c:choose>
        </span>
        <span id="weakRequisitesForDisplay">
          <c:if test="${not empty rule}">
           <tiles:insert page="weakDependency.jsp" flush="true">
             <tiles:put name="rule" beanName="rule" />
             <tiles:put name="none" value="" />
           </tiles:insert>
          </c:if>
        </span>
     </td>
     <td>&nbsp;</td>
   </tr>

   <tr class="ruleIdeTableDataRow"><td colspan="9" valign="top" class="ruleIdeTableLabel">&nbsp;</td></tr>

   <%-- Value of usedVariables is set when rule code is parsed (updated variables are marked with * in display) --%>
   <input type="hidden" name="usedVariables"      id="usedVariables"      value="?" />
   <input type="hidden" name="usedVariableIds"    id="usedVariableIds"    value="${usedVariableIds}" />
   <input type="hidden" name="changedVariables"   id="changedVariables"   value="?" />
   <input type="hidden" name="changedVariableIds" id="changedVariableIds" value="${changedVariableIds}" />

   <tr class="ruleIdeTableDataRow" >
     <td valign="top" nowrap class="ruleIdeTableLabel"><fmt:message key="rules.rule.used.variables.txt"/>:&nbsp;</td>
     <td valign="top" colspan="7" style="padding:0px 0px 0px 0px;text-align:left;"><span id="usedVariablesForDisplay"></span></td>
     <td>&nbsp;</td>
   </tr>

</TABLE>



