options nocenter ls=180 ps=max compress=yes;

/*
mdchash library definition
*/
options
  symbolgen
  mprint
  ;

%let sasroot = %sysfunc(sysget(SASROOT));
%let sasfmcp = %sysfunc(sysget(SASFMCP_IMPLEMENT_HOME));
%let models_home=%sysfunc(sysget(SAS_MODELS_HOME));

%if "&models_home." eq "" %then
%do;
   %put ERROR: CPP2SDS - SAS_MODELS_HOME is not defined;
   data _null;
      stop;
   run;
%end;

libname mdchash "&models_home./mdchash";

%let cpp_card_file=;

%let cpp_card_file=%sysfunc(sysget(CPP_CARD_FILE));

%if "&cpp_card_file" eq "" %then
%do;
   %put ERROR: CPP2SDS - CPP_CARD_FILE is not defined;
   data _null;
      stop;
   run;
%end;

%put &=cpp_card_file;

data mdchash.cpp_card_list(encoding=cp1047);
  infile "&cpp_card_file";
  input
    @1     HQO_CARD_NUM          $char20.
    @21    CPP_ENT_ID_1          $char4.
    @25    CPP_ENT_ID_2          $char4.
    @29    CPP_ENT_ID_3          $char4.
    @33    CPP_ENT_FRDRATE_1     best8.
    @41    CPP_ENT_FRDRATE_2     best8.
    @49    CPP_ENT_FRDRATE_3     best8.
    @57    CPP_ENT_FRD_PT1_1     $1.
    @58    CPP_ENT_FRD_PT1_2     $1.
    @59    CPP_ENT_FRD_PT1_3     $1.
    @60    CPP_CARD_EXP_DATE_PRX yymmdd8.
    @68    CPP_LIST_DATE         yymmdd8.
    @76    CPP_CARD_FRD_STATUS   $1.
   ;
run;