%macro global_setup;

options papersize=a3;

    %global
        title
        type_freq
        cellwidth
        report_date9
        development_begin_date
        development_end_date
        report_path
        indataset
        config_dataset
        fmtlib
        cindex1
        cindex2_P
        cindex2_D
        output_recode_ds
        proc_report_statistic
        frh_table
        ;

    %let type_freq=%lowcase(%scan(&type, -1, "_"));


    %let report_path=&report_root./report_output/%trim(%lowcase(&type))/;
    X "mkdir -p &report_path";    

    %let fmtlib=devdata.formats;   
    options fmtsearch=(work &fmtlib library sasuser);
    
    %if %in1(&type,DEV_DAILY DEV_MONTHLY) %then
        %let config_dataset=devdata.parameters_%trim(%lowcase(%SCAN(&type,-1,_))); 
    %else
        %let config_dataset=devdata.parameters_%lowcase(&type);


    /* set up combined development test data */
    %if (%index(%lowcase(&input_dataset),.sas7bdat) GE 1)
        and (%index(%lowcase(&input_dataset),/) GE 1)
        %then %do;

        data _null_;
            x=strip("&input_dataset");
            y=scan(x,-1,'/');
            dsonly=scan(y,1,'.');
            z=indexw(x,strip(y),'/');
            inlib=substr(x,1,z-2);
            call symputx('inlib', inlib);
            call symputx('indataset', dsonly);
        run;
        libname inlib "&inlib" access = readonly;
    %end;
    
    %let cindex1=3;     **** column for stability index comparison - main comparison - usually set to current column percentage;
    %let cindex2_P=5;   **** column for stability index comparison if stability index parameter is set to previous;
    %let cindex2_D=7;   **** column for stability index comparison if stability index parameter is set to development;

    %let cellwidth=1.0in;
    %let proc_report_statistic=SUM;

    
    %put _user_;

%mend global_setup;
