%macro global_setup_quarterly;

options papersize=a3;

    %global
        inlib
        indataset
        INCLUDE_POSTINGS
        USE_AFD
        APIVERSION
        dbkeeplist
        ;

    %let report_path=&report_root./report_output/%trim(%lowcase(&type))/&dev_data_acronym;
    X "mkdir -p &report_path";
    X "mkdir -p &report_root./data/quarterly";

    libname init   "&report_root./data/development_data";
    libname qtrlib "&report_root./data/development_data/quarterly";

    %let fmtlib=init.formats;   
    options fmtsearch=(work &fmtlib library sasuser);
    

    /* set up combined development test data */
    %if (%index(%lowcase(&input_dataset),.sas7bdat) GE 1)
        and (%index(%lowcase(&input_dataset),/) GE 1)
        %then %do;

        data _null_;
            x=strip("&input_dataset");
            y=scan(x,-1,'/');
            dsonly=scan(y,1,'.');
            z=indexw(x,strip(y),'/');
            inlib=substr(x,1,z-2);
            call symputx('inlib', inlib);
            call symputx('indataset', dsonly);
        run;
        libname inlib "&inlib" access = readonly;
    %end;

    %let INCLUDE_POSTINGS=0; 
    %let USE_AFD=1; 
    %let APIVERSION=4; 

%mend global_setup_quarterly;
