/*
 * extract production data for analytic reporting
 *
 * Author: Szczuka, William 2015
 *
 */

%macro rpt_extract_production_data(
    frh_table,            /* CCCA, CSCA, etc */
    type,                 /* daily, monthly */
    wherecond = 1,        /* conditions to subsetting input dataset */
    wts_var = 1           /* weight of each observation */
  );


    %local var_list;
    proc sql noprint;
        select var_list into :var_list /*separated by  " "*/
            from devdata.frh_table_info_&type.
            where frh_table = "&frh_table";
    quit;

    %let var_list = &var_list;
    
    %put var_list: &var_list;
    /* connect to analytic datasets */

    /* connect to analytic datasets */
    %fsmetl_ads_extract(fcm_&frh_table, &var_list, &wherecond, &frh_table, );

    data &frh_table;
      set &frh_table; 
      length wts_var 8;
      wts_var = &wts_var;
    run;


%mend rpt_extract_production_data;
